//--------------- chaos mod stuff ----------------------//

//for m = MT_INVADERMISSLE
	local info = mobjinfo[MT_INVADERMISSSLE]
	info.name = 'inferno missle'
	info.article = 'an'
//end


//for s = MT_INVADER_INFERNOEYE
	local info = mobjinfo[MT_INVADER_INFERNOEYE]
	info.name = 'swirling inferno'
	info.article = 'a'
//end


//for i = MT_INVADERPILOT
	local info = mobjinfo[MT_INVADERPILOT]
	info.chaosmode = true
	info.spawntype = 'target' //Valid arguments: enemy, target, hazard.
	info.spawnsubtype = {'air'}	//Valid arguments: land, air, water, watersurface, ceiling, sniper
	info.name = 'Invader'
	info.article = nil
	info.difficulty = DIFF_MIDBOSS // 
	info.spawnbiome = 'metal'
	info.spawnpriority = 1
	info.spawnweight = 2
	info.spawnfrequency = 2
	info.spawnangle = true
	info.spawnstill = false
	info.darksky = false
	info.music = nil
	info.grounded = false
	info.bumptype = 2 // heavy? dont let players push you
	info.scale = FRACUNIT
	info.color = nil
	//info.custompainsound = sfx_dmpain
	info.harmless = false // prevent contact damage
	
	info.flashingtime = 24
	info.flincharmor = false
	info.shadowscale = nil
	info.bossregulate = nil
	
	addHook('MobjSpawn',function(mo)
		if CBW_Chaos_Library //Always perform this check before running Chaos specific functions!
			CBW_Chaos_Library.EnemyInit(mo) //Initialized all of the object variables used by Chaos. (
		end
	end,MT_INVADERPILOT)
	addHook('MobjThinker',function(mo)
		if CBW_Chaos_Library 
			CBW_Chaos_Library.MobjCheckWater(mo) //Optional. Reproduces (slightly modified) water physics that only pushables and players got to use previously.
			
			if CBW_Chaos_Library.EnemyTic_Flashing(mo) //Regulates the flashing state. Returns true if the enemy is still invulnerable.
				return true //If we want, we can use this to freeze the enemy in place while taking damage.
			end
		end
	end,MT_INVADERPILOT)
//end

//------------------------------------------------------//

//for p = MT_JETRBULLET
	local info = mobjinfo[MT_JETRBULLET]
	info.name = 'laser bullet'
	info.article = 'a'
//end

//for j = MT_JETTRUNNER
	local info = mobjinfo[MT_JETTRUNNER]
	info.chaosmode = true
	info.spawntype = 'enemy' //Valid arguments: enemy, target, hazard.
	info.spawnsubtype = {'land','sniper'}	//Valid arguments: land, air, water, watersurface, ceiling, sniper
	info.name = 'Jetty-Syn Runner'
	info.article = nil
	info.difficulty = DIFF_HARD // DIFF_HARD just because i want them to spawn with the gunners
	info.spawnbiome = 'metal'
	info.spawnpriority = 1
	info.spawnweight = 2
	info.spawnfrequency = 3
	info.spawnangle = false
	info.spawnstill = false
	info.darksky = false
	info.music = nil
	info.grounded = false
	info.bumptype = 2 // heavy? dont let players push you
	info.scale = FRACUNIT
	info.color = SKINCOLOR_DUSK
	//info.custompainsound = sfx_dmpain
	info.harmless = false
	
	info.flashingtime = 24
	info.flincharmor = false
	info.shadowscale = nil
	info.bossregulate = 1
	
	addHook('MobjSpawn',function(mo)
		if CBW_Chaos_Library //Always perform this check before running Chaos specific functions!
			CBW_Chaos_Library.EnemyInit(mo) //Initialized all of the object variables used by Chaos. (
		end
	end,MT_JETTRUNNER)
	addHook('MobjThinker',function(mo)
		if CBW_Chaos_Library 
			CBW_Chaos_Library.MobjCheckWater(mo) //Optional. Reproduces (slightly modified) water physics that only pushables and players got to use previously.
			if CBW_Chaos_Library.EnemyTic_Flashing(mo) //Regulates the flashing state. Returns true if the enemy is still invulnerable.
				return 
			end
		end
	end,MT_JETTRUNNER)
//end

//------------------------------------------------------//

//for b = MT_TURBBULLET
	local info = mobjinfo[MT_TURBBULLET]
	info.name = 'turbo bullet'
	info.article = 'a'
//end

//for w = MT_TURBFLAMEWALL
	local info = mobjinfo[MT_TURBFLAMEWALL]
	info.name = 'turbo flame wall'
	info.article = 'a'
//end


//for t = MT_TURBOBUZZ
	local info = mobjinfo[MT_TURBOBUZZ]
	info.chaosmode = true
	info.spawntype = 'enemy' //Valid arguments: enemy, target, hazard.
	info.spawnsubtype = {'land'}	//Valid arguments: land, air, water, watersurface, ceiling, sniper
	info.name = 'Turbo Buzz'
	info.article = nil
	info.difficulty = 1 // low difficulty but not too low
	info.spawnbiome = 'metal'
	info.spawnpriority = 1
	info.spawnweight = 2
	info.spawnfrequency = 2
	info.spawnangle = true
	info.spawnstill = true
	info.darksky = false
	info.music = nil
	info.grounded = false
	info.bumptype = 0 // light
	info.scale = FRACUNIT
	info.color = SKINCOLOR_SEAFOAM
	//info.custompainsound = sfx_dmpain
	info.harmless = true // prevent contact damage
	
	info.flashingtime = 24
	info.flincharmor = true
	info.shadowscale = nil
	info.bossregulate = nil
	
	addHook('MobjSpawn',function(mo)
		if CBW_Chaos_Library //Always perform this check before running Chaos specific functions!
			CBW_Chaos_Library.EnemyInit(mo) //Initialized all of the object variables used by Chaos. (
		end
	end,MT_TURBOBUZZ)
	addHook('MobjThinker',function(mo)
		if CBW_Chaos_Library 
			CBW_Chaos_Library.MobjCheckWater(mo) //Optional. Reproduces (slightly modified) water physics that only pushables and players got to use previously.
			
			if CBW_Chaos_Library.EnemyTic_Flashing(mo) //Regulates the flashing state. Returns true if the enemy is still invulnerable.
				return true //If we want, we can use this to freeze the enemy in place while taking damage.
			end
		end
	end,MT_TURBOBUZZ)
//end

//------------------------------------------------------//

//for l = MT_EGG_BEATER_MELEE
	local info = mobjinfo[MT_EGG_BEATER_MELEE]
	info.name = "Egg Beater's lance"
	info.article = 'the'
//end

//for e = MT_EGG_BEATER
	local info = mobjinfo[MT_EGG_BEATER]
	info.chaosmode = true
	info.spawntype = 'target' //Valid arguments: enemy, target, hazard.
	info.spawnsubtype = {'land'}	//Valid arguments: land, air, water, watersurface, ceiling, sniper
	info.name = 'Dr. Eggman (Egg Beater)' //'Dr. Eggman (Egg Marine)'
	info.article = nil
	info.difficulty = 4 // DIFF_BOSS
	info.spawnbiome = 'medieval'
	info.spawnpriority = 0
	info.spawnweight = 3
	info.spawnfrequency = 1
	info.spawnangle = true
	info.spawnstill = false
	info.darksky = false
	info.music = nil
	info.grounded = false
	info.bumptype = 2 // heavy? dont let players push you
	info.scale = FRACUNIT
	info.color = nil
	//info.custompainsound = sfx_dmpain
	info.harmless = false 
	
	info.flashingtime = 24
	info.flincharmor = true
	info.shadowscale = nil
	info.bossregulate = 1
	
	addHook('MobjSpawn',function(mo)
		if CBW_Chaos_Library //Always perform this check before running Chaos specific functions!
			CBW_Chaos_Library.EnemyInit(mo) //Initialized all of the object variables used by Chaos. 
		end
	end,MT_EGG_BEATER)
	addHook('MobjThinker',function(mo)
		if CBW_Chaos_Library 
			CBW_Chaos_Library.MobjCheckWater(mo) //Optional. Reproduces (slightly modified) water physics that only pushables and players got to use previously.
			
			if CBW_Chaos_Library.EnemyTic_Flashing(mo) //Regulates the flashing state. Returns true if the enemy is still invulnerable.
				return false //If we want, we can use this to freeze the enemy in place while taking damage.
			end
		end
	end,MT_EGG_BEATER)
//end

//------------------------------------------------------//
	