freeslot(
"MT_EGG_BEATER",
"MT_EGG_BEATER_MELEE",
"MT_EGG_BEATER_CHARGE",
"MT_EGG_BEATER_PART",
"MT_EGG_BEATER_TARGET",
"S_EGG_BEATER_CHASE",
"S_EGG_BEATER_MELEE1",
"S_EGG_BEATER_MELEE2",
"S_EGG_BEATER_MELEE3",
"S_EGG_BEATER_MELEE4",
"S_EGG_BEATER_JUMP1",
"S_EGG_BEATER_JUMP2",
"S_EGG_BEATER_JUMP3",
"S_EGG_BEATER_JUMP4",
"S_EGG_BEATER_JUMP5",
"S_EGG_BEATER_GUN1",
"S_EGG_BEATER_GUN2",
"S_EGG_BEATER_GUN3",
"S_EGG_BEATER_GUN4",
"S_EGG_BEATER_GUN5",
"S_EGG_BEATER_PAIN",
"S_EGG_BEATER_DIE1",
"S_EGG_BEATER_DIE2",
"S_EGG_BEATER_DIE3",
"S_EGG_BEATER_DIE4",
"S_EGG_BEATER_SWORD",
"S_EGG_BEATER_CHARGE",
"S_EGG_BEATER_TARGET1",
"S_EGG_BEATER_TARGET2",
"S_EGG_BEATER_FLEE1",
"S_EGG_BEATER_FLEE2",
"S_EGG_BEATER_BODY1",
"S_EGG_BEATER_BODY2",
"S_EGG_BEATERLEFTARM1",
"S_EGG_BEATERLEFTARM2",
"S_EGG_BEATERRIGHTARM1",
"S_EGG_BEATERRIGHTARM2",
"SPR_EBEA",
"SPR_EBOD",
"SPR_EBLA",
"SPR_EBRA"
)
	
if not(kirbyabilitytable) // kirby compatability
	rawset(_G, "kirbyabilitytable", {})
end
if kirbyabilitytable then 
	kirbyabilitytable[MT_TURBOBUZZ] = 8 // weel
	kirbyabilitytable[MT_JETTRUNNER] = -4 // gun?
	kirbyabilitytable[MT_INVADERMISSSLE] = 4 //  bomb
	kirbyabilitytable[MT_INVADERPILOT] = 16 // ufo
end

function A_EggBeaterMelee (actor, var1, var2)
	local visang = R_PointToAngle2(actor.x, actor.y, actor.target.x, actor.target.y)
	local dirang = actor.angle
	local diffang = visang - dirang
	
end

mobjinfo[MT_EGG_BEATER] = {
doomednum = 4002,
spawnstate = S_EGG_BEATER_CHASE,
seestate = S_EGG_BEATER_CHASE,
attacksound = sfx_zoom,
painstate = S_EGG_BEATER_PAIN,
deathstate = S_EGG_BEATER_DIE1,
xdeathstate = S_EGG_BEATER_FLEE1,
activesound = sfx_s3kc5s,
painsound = sfx_dmpain,
deathsound = sfx_s3kb4,
spawnhealth = 16,
reactiontime = 45,
speed = 3,
radius = 36*FRACUNIT,
height = 106*FRACUNIT,
mass = 100,
flags = MF_SPECIAL|MF_SHOOTABLE|MF_BOSS
}

mobjinfo[MT_EGG_BEATER_MELEE] = {
spawnstate = S_EGG_BEATER_SWORD,
seestate = S_EGG_BEATER_SWORD,
attacksound = sfx_zoom,
painstate = S_EGG_BEATER_SWORD,
deathstate = S_NULL,
activesound = sfx_s3kc5s,
painsound = sfx_dmpain,
deathsound = sfx_cybdth,
spawnhealth = 999,
reactiontime = 45,
speed = 3,
radius = 28*FRACUNIT,
height = 58*FRACUNIT,
mass = 100,
flags = MF_PAIN|MF_NOCLIPHEIGHT
}

mobjinfo[MT_EGG_BEATER_CHARGE] = {
spawnstate = S_EGG_BEATER_CHARGE,
seestate = S_EGG_BEATER_CHARGE,
attacksound = sfx_zoom,
painstate = S_EGG_BEATER_CHARGE,
deathstate = S_NULL,
activesound = sfx_s3kc5s,
painsound = sfx_dmpain,
deathsound = sfx_cybdth,
spawnhealth = 999,
reactiontime = 45,
speed = 3,
radius = 33*FRACUNIT,
height = 62*FRACUNIT,
mass = 100,
flags = MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

mobjinfo[MT_EGG_BEATER_TARGET] = {
spawnstate = S_EGG_BEATER_TARGET1,
seestate = S_EGG_BEATER_TARGET1,
attacksound = sfx_zoom,
painstate = S_EGG_BEATER_TARGET1,
deathstate = S_NULL,
activesound = sfx_s3kc5s,
painsound = sfx_dmpain,
deathsound = sfx_cybdth,
spawnhealth = 999,
reactiontime = 45,
speed = 3,
radius = 33*FRACUNIT,
height = 62*FRACUNIT,
mass = 100,
flags = MF_NOCLIP|MF_NOCLIPHEIGHT
}

//-------------dead parts---------------//
mobjinfo[MT_EGG_BEATER_PART] = {
spawnstate = S_EGG_BEATER_BODY1,
seestate = S_EGG_BEATER_BODY1,
attacksound = sfx_zoom,
painstate = S_EGG_BEATER_BODY1,
deathstate = S_NULL,
activesound = sfx_s3kc5s,
painsound = sfx_dmpain,
deathsound = sfx_cybdth,
spawnhealth = 999,
reactiontime = 45,
speed = 3,
radius = 33*FRACUNIT,
height = 60*FRACUNIT,
mass = 100,
flags = MF_NOCLIP|MF_NOCLIPHEIGHT
}

//-----------------states-----------------------------//
states[S_EGG_BEATER_SWORD] = {
sprite = S_NULL,
frame = A,
tics = 1,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_SWORD 
}

states[S_EGG_BEATER_CHARGE] = {
sprite = SPR_STAB,
frame = TR_TRANS30|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
tics = 15,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_NULL
}

states[S_EGG_BEATER_TARGET1] = {
sprite = SPR_TARG,
frame = TR_TRANS40|FF_FULLBRIGHT|A,
tics = 1,
action = A_CapeChase,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_TARGET2
}

states[S_EGG_BEATER_TARGET2] = {
sprite = SPR_TARG,
frame = TR_TRANS20|FF_FULLBRIGHT|A,
tics = 1,
action = A_CapeChase,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_TARGET1
}

states[S_EGG_BEATER_CHASE] = {
sprite = SPR_EBEA,
frame = A,
tics = 1,
action = A_Chase,
var1 = 3,
var2 = 0,
nextstate = S_EGG_BEATER_CHASE 
}

states[S_EGG_BEATER_PAIN] = {
sprite = SPR_EBEA,
frame = A,
tics = 24,
action = A_Pain,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_CHASE 
}

states[S_EGG_BEATER_MELEE1] = {
sprite = SPR_EBEA,
frame = B,
tics = 0,
action = A_FaceTarget,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_MELEE2
}

states[S_EGG_BEATER_MELEE2] = {
sprite = SPR_EBEA,
frame = B,
tics = 1,
action = A_FaceStabRev,
var1 = 20,
var2 = S_EGG_BEATER_MELEE3,
nextstate = S_EGG_BEATER_MELEE2
}

states[S_EGG_BEATER_MELEE3] = {
sprite = SPR_EBEA,
frame = C,
tics = 245,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_MELEE4
}

states[S_EGG_BEATER_MELEE4] = {
sprite = SPR_EBEA,
frame = C,
tics = 5,
action = A_FaceStabMiss,
var1 = 0,
var2 = S_EGG_BEATER_CHASE,
nextstate = S_EGG_BEATER_MELEE4
}

states[S_EGG_BEATER_JUMP1] = {
sprite = SPR_EBEA,
frame = F,
tics = 1,
action = A_FaceTarget,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_JUMP2
}

states[S_EGG_BEATER_JUMP2] = {
sprite = SPR_EBEA,
frame = F,
tics = 65,
action = A_BunnyHop,
var1 = 20,
var2 = 8,
nextstate = S_EGG_BEATER_JUMP3
}

states[S_EGG_BEATER_JUMP3] = {
sprite = SPR_EBEA,
frame = G,
tics = 65,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_JUMP4
}

states[S_EGG_BEATER_JUMP4] = {
sprite = SPR_EBEA,
frame = H,
tics = 1,
action = A_Boss5CheckOnGround,
var1 = S_EGG_BEATER_JUMP5,
var2 = S_EGG_BEATER_JUMP5,
nextstate = S_EGG_BEATER_JUMP4
}

states[S_EGG_BEATER_JUMP5] = {
sprite = SPR_EBEA,
frame = I,
tics = 15,
action = A_MultiShot,
var1 = (MT_TURBFLAMEWALL<<16)+24,
var2 = -20,
nextstate = S_EGG_BEATER_CHASE
}

states[S_EGG_BEATER_GUN1] = {
sprite = SPR_EBEA,
frame = D,
tics = 1,
action = A_FaceTarget,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_GUN1
}

states[S_EGG_BEATER_GUN2] = {
sprite = SPR_EBEA,
frame = D,
tics = 2,
action = A_Thrust,
var1 = -6,
var2 = 1,
nextstate = S_EGG_BEATER_GUN3
}

states[S_EGG_BEATER_GUN3] = {
sprite = SPR_EBEA,
frame = FF_FULLBRIGHT|E,
tics = 2,
action = A_FireShot,
var1 = MT_INVADERMISSSLE,
var2 = 50,
nextstate = S_EGG_BEATER_GUN4
}

states[S_EGG_BEATER_GUN4] = {
sprite = SPR_EBEA,
frame = D,
tics = 35,
action = A_FindTarget,
var1 = MT_PLAYER,
var2 = 0,
nextstate = S_EGG_BEATER_GUN5
}

states[S_EGG_BEATER_GUN5] = {
sprite = SPR_EBEA,
frame = D,
tics = 1,
action = A_Repeat,
var1 = 3,
var2 = S_EGG_BEATER_GUN1,
nextstate = S_EGG_BEATER_CHASE
}

states[S_EGG_BEATER_DIE1] = {
sprite = SPR_EBEA,
frame = A,
tics = 2,
action = A_BossScream,
var1 = 0,
var2 = MT_SONIC3KBOSSEXPLODE,
nextstate = S_EGG_BEATER_DIE2 
}

states[S_EGG_BEATER_DIE2] = {
sprite = SPR_EBEA,
frame = A,
tics = 2,
action = A_BossScream,
var1 = 0,
var2 = MT_SONIC3KBOSSEXPLODE,
nextstate = S_EGG_BEATER_DIE3
}

states[S_EGG_BEATER_DIE3] = {
sprite = SPR_EBEA,
frame = A,
tics = 2,
action = A_Repeat,
var1 = 24,
var2 = S_EGG_BEATER_DIE1,
nextstate = S_EGG_BEATER_DIE4
}

states[S_EGG_BEATER_DIE4] = {
sprite = SPR_EBEA,
frame = A,
tics = -1,
action = A_BossDeath,
var1 = 0,
var2 = 0,
nextstate = S_NULL
}

states[S_EGG_BEATER_FLEE1] = {
sprite = SPR_EGGM,
frame = V,
tics = 2,
action = A_BossScream,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_FLEE2 
}

states[S_EGG_BEATER_FLEE2] = {
sprite = SPR_EGGM,
frame = W,
tics = 2,
action = A_BossScream,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_FLEE1
}

//--dead parts ----------------------//
states[S_EGG_BEATER_BODY1] = {
sprite = SPR_EBOD,
frame = A,
tics = 2,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_BODY2
}

states[S_EGG_BEATER_BODY2] = {
sprite = S_NULL,
frame = A,
tics = 2,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATER_BODY1
}

//--//
states[S_EGG_BEATERLEFTARM1] = {
sprite = SPR_EBLA,
frame = A,
tics = 2,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATERLEFTARM2
}

states[S_EGG_BEATERLEFTARM2] = {
sprite = S_NULL,
frame = A,
tics = 2,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATERLEFTARM1
}

//--//
states[S_EGG_BEATERRIGHTARM1] = {
sprite = SPR_EBRA,
frame = A,
tics = 2,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATERRIGHTARM2
}

states[S_EGG_BEATERRIGHTARM2] = {
sprite = S_NULL,
frame = A,
tics = 2,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_EGG_BEATERRIGHTARM1
}

addHook("MobjSpawn", function(mo)
    mo.jetfume1 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_JETFUMEO1)
    mo.jetfume2 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_JETFUMEO1)
    mo.jetfume3 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_JETFUMEO1)
    mo.jetfume1.tracer = mo
    mo.jetfume2.tracer = mo
    mo.jetfume3.tracer = mo
end, MT_EGG_BEATER)

addHook("MobjThinker", function(mo)
	if mo.valid and mo then
		if mo.lifetimmer == nil then
			mo.lifetimmer = 1
		end
		mo.lifetimmer = $+1
		if mo.lifetimmer >= TICRATE*4 then
			mo.state = S_NULL
		end
	end
end, MT_EGG_BEATER_PART)

addHook("MobjThinker", function(mo) //--------//
	if mo.attacktimmer == nil then
		mo.attacktime = TICRATE*2
		mo.attacktimmer = 0
		mo.attacknumber = 0 //0
		mo.attackspeed = 1*FRACUNIT
		mo.stopsoon = 0
		mo.attackweapon = 0
		mo.swordslamsound = false
		mo.usegun = 0 //0
		mo.guntime = 0 // the startup before fireing the three missles
		mo.targeteffect = 0
		mo.ohnos = false
		mo.fofless = false
		mo.dropparts = false // when dead spawn pices
		mo.dashjump = false
		mo.allycheck1 = false
		mo.allycheck2 = false
	end
	
	if mo.dropparts == false and mo.state == S_EGG_BEATER_FLEE1 then
		mo.bodypart = P_SpawnMobj(mo.x+FixedMul(30*FRACUNIT, cos(mo.angle)),  
			mo.y+FixedMul(30*FRACUNIT, sin(mo.angle)), mo.z-10*FRACUNIT, MT_EGG_BEATER_PART)
		mo.bodypart.angle = mo.angle
		P_InstaThrust(mo.bodypart, mo.angle, FixedMul((1*FRACUNIT), mo.scale))
		A_ZThrust(mo.bodypart, 1, (1<<16)+0)
		
		mo.leftpart = P_SpawnMobj(mo.x+FixedMul(90*FRACUNIT, cos(mo.angle-ANGLE_90)),  
			mo.y+FixedMul(90*FRACUNIT, sin(mo.angle-ANGLE_90)), mo.z-30*FRACUNIT, MT_EGG_BEATER_PART)
		mo.leftpart.angle = mo.angle
		P_InstaThrust(mo.leftpart, mo.angle-ANGLE_90, FixedMul((1*FRACUNIT), mo.scale))
		mo.leftpart.state = S_EGG_BEATERLEFTARM1
		A_ZThrust(mo.leftpart, 1, (1<<16)+0)
		
		mo.rightpart = P_SpawnMobj(mo.x+FixedMul(90*FRACUNIT, cos(mo.angle+ANGLE_90)),  
			mo.y+FixedMul(90*FRACUNIT, sin(mo.angle+ANGLE_90)), mo.z-30*FRACUNIT, MT_EGG_BEATER_PART)
		mo.rightpart.state = S_EGG_BEATERRIGHTARM1
		mo.rightpart.angle = mo.angle 
		P_InstaThrust(mo.rightpart, mo.angle+ANGLE_90, FixedMul((1*FRACUNIT), mo.scale))
		A_ZThrust(mo.rightpart, 1, (1<<16)+0)
		
		mo.dropparts = true
	end
	
	if mo.state == S_EGG_BEATER_FLEE1 or mo.state == S_EGG_BEATER_FLEE2 then
		if mo.jetfume1 and mo.jetfume1.valid then
			P_TeleportMove(mo.jetfume1, mo.x - 54 * cos(mo.angle), mo.y - 54 * sin(mo.angle), mo.z + (38*FRACUNIT))
			mo.jetfume1.momx = mo.momx*2
			mo.jetfume1.momy = mo.momy*2
		end
		if mo.jetfume2 and mo.jetfume2.valid then
			P_TeleportMove(mo.jetfume2, mo.x - 54 * cos(mo.angle) - 22*cos(mo.angle-ANGLE_90), mo.y - 54 * sin(mo.angle) - 22*sin(mo.angle-ANGLE_90), mo.z + (10*FRACUNIT))
			mo.jetfume2.momx = mo.momx*2
			mo.jetfume2.momy = mo.momy*2
		end
		if mo.jetfume3 and mo.jetfume3.valid then
			P_TeleportMove(mo.jetfume3, mo.x - 54 * cos(mo.angle) - 22*cos(mo.angle+ANGLE_90), mo.y - 54 * sin(mo.angle) - 22*sin(mo.angle+ANGLE_90), mo.z + (10*FRACUNIT))
			mo.jetfume3.momx = mo.momx*2
			mo.jetfume3.momy = mo.momy*2
		end
	else
		if mo.jetfume1 and mo.jetfume1.valid then
			P_TeleportMove(mo.jetfume1, mo.x - 67 * cos(mo.angle), mo.y - 67 * sin(mo.angle), mo.z + (70*FRACUNIT))
			mo.jetfume1.momx = mo.momx*2
			mo.jetfume1.momy = mo.momy*2
		end
		if mo.jetfume2 and mo.jetfume2.valid then
			P_TeleportMove(mo.jetfume2, mo.x - 66 * cos(mo.angle) - 22*cos(mo.angle-ANGLE_90), mo.y - 66 * sin(mo.angle) - 24*sin(mo.angle-ANGLE_90), mo.z + (42*FRACUNIT))
			mo.jetfume2.momx = mo.momx*2
			mo.jetfume2.momy = mo.momy*2
		end
		if mo.jetfume3 and mo.jetfume3.valid then
			P_TeleportMove(mo.jetfume3, mo.x - 66 * cos(mo.angle) - 22*cos(mo.angle+ANGLE_90), mo.y - 66 * sin(mo.angle) - 24*sin(mo.angle+ANGLE_90), mo.z + (42*FRACUNIT))
			mo.jetfume3.momx = mo.momx*2
			mo.jetfume3.momy = mo.momy*2
		end
	end
	
	if mo.state == S_EGG_BEATER_CHASE then
	mo.attacktimmer = $+1
	mo.stopsoon = 0
	mo.ohnos = false
	mo.fofless = false
		if mo.usegun >= 2 then //go to gun fater
		mo.attacktimmer = $+1
		end
	end
	
	if mo.health <= 6 and mo.attacktime == TICRATE*2 then
		mo.attacktime = TICRATE // enter "pinch phase"
	end
	
	if mo.attacktimmer > mo.attacktime and mo.state == S_EGG_BEATER_CHASE and mo.target and mo.target.valid  then
		if mo.usegun >= 2 then // use gun
		mo.state = S_EGG_BEATER_GUN1
		mo.attacknumber = 0
		mo.attacktimmer = 0
		mo.attackspeed = 1*FRACUNIT
		mo.guntime = 0
		mo.usegun = 0 //0
		S_StartSound(mo, 666, nil) // pull out gun
		S_StartSound(mo, 666, nil) // too lazzy to figure out how S_StartSoundAtVolume works
		elseif mo.attacknumber < 2 then // go do melee attak
		mo.state = S_EGG_BEATER_MELEE1
		mo.attacknumber = $+1
		mo.attacktimmer = 0
		mo.stopsoon = 0
		mo.attackspeed = 1*FRACUNIT
		mo.attackweapon = 0
		mo.dashjump = false
			if not P_CheckSight(mo, mo.target) then // try to change target
			A_FindTarget(mo, MT_PLAYER, 0)
			end
		elseif mo.attacknumber >= 2 then // go do jump attack
		mo.state = S_EGG_BEATER_JUMP1
		mo.attacknumber = 0 //0
		mo.attacktimmer = TICRATE // attack faster
		mo.stopsoon = 0
		mo.attackspeed = 1*FRACUNIT
		mo.attackweapon = 0
		S_StartSound(mo, 26, nil) // jump sound/ wacky work bench
		mo.usegun = $+1 // after doing two jumps do gun attack
		mo.swordslamsound = true
		end
	end
	if mo.state == S_EGG_BEATER_MELEE3 then // mele3 charge attack
		if mo.attackweapon == 0 then
			mo.attackweapon = P_SpawnMobj(mo.x+FixedMul(130*FRACUNIT, cos(mo.angle)),  
		mo.y+FixedMul(130*FRACUNIT, sin(mo.angle)), mo.z, MT_EGG_BEATER_MELEE)
			mo.attackweapon.target = mo
			mo.attackweapon.effecttime = 0
		end
		if mo.z-(10*FRACUNIT) > mo.floorz and mo.momz < 0 and mo.dashjump == false then
			A_ZThrust(mo, 4, (1<<16)+0)
			mo.dashjump = true
		end
	P_InstaThrust(mo, mo.angle, FixedMul((mo.attackspeed), mo.scale))
	if mo.target and mo.target.valid then
		local visang = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
		local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
			if dist and dist < 50*FRACUNIT and mo.stopsoon == 0 then
			mo.stopsoon = 1
			end
			if mo.stopsoon > 0 then
				mo.stopsoon = $+1
			else
			mo.angle = visang
			end
		end
		if mo.attackspeed < 30*FRACUNIT  and mo.ohnos == false then
		mo.attackspeed = $+(1*FRACUNIT)
		else // if close and fast stop tracking and go to next state after some time
		mo.attackspeed = $+(FRACUNIT/8)
			if mo.stopsoon > TICRATE/5 or mo.ohnos == true then
			mo.state = S_EGG_BEATER_MELEE4
			mo.stopsoon = 0
			end
		end
		if mo.attackweapon and mo.attackweapon.valid then
			local attackweapon = mo.attackweapon
			P_TeleportMove(attackweapon, mo.x+FixedMul(130*FRACUNIT, cos(mo.angle)),
			mo.y+FixedMul(130*FRACUNIT, sin(mo.angle)), (mo.z))
			attackweapon.angle = mo.angle+ANGLE_90
			attackweapon.momx = mo.momx
			attackweapon.momy = mo.momy
			attackweapon.momz = mo.momz
		end
	end//----------------------------//
	if mo.state == S_EGG_BEATER_JUMP2 and mo.momz <= 5*FRACUNIT then // change state when near the top of a jump
	mo.state = S_EGG_BEATER_JUMP3
		if mo.ohnos == false and mo.momx < 7*FRACUNIT and mo.momx > -7*FRACUNIT and mo.momy < 7*FRACUNIT and mo.momy > -7*FRACUNIT then
		P_InstaThrust(mo, mo.angle, FixedMul((7*FRACUNIT), mo.scale))
		end
	end
	if mo.state == S_EGG_BEATER_JUMP3 and mo.momz < 0*FRACUNIT then // change state when falling fast enough
	mo.state = S_EGG_BEATER_JUMP4
	end
	if mo.state == S_EGG_BEATER_JUMP4 then // place attack box bellow when falling
		if mo.attackweapon == 0 then
			mo.attackweapon = P_SpawnMobj(mo.x+FixedMul(1*FRACUNIT, cos(mo.angle)),  
			mo.y+FixedMul(1*FRACUNIT, sin(mo.angle)), mo.z-90*FRACUNIT, MT_EGG_BEATER_MELEE)
			mo.attackweapon.target = mo
			mo.attackweapon.effecttime = 0
		end
		if mo.attackweapon and mo.attackweapon.valid then
			local attackweapon = mo.attackweapon
			P_TeleportMove(attackweapon, mo.x+FixedMul(1*FRACUNIT, cos(mo.angle)),
			mo.y+FixedMul(1*FRACUNIT, sin(mo.angle)), (mo.z-90*FRACUNIT))
			attackweapon.angle = mo.angle
			attackweapon.momx = mo.momx
			attackweapon.momy = mo.momy
			attackweapon.momz = mo.momz
		end
	end//----------------------------//
	if mo.state == S_EGG_BEATER_JUMP5 then // do sound 
		if mo.swordslamsound == true then
		S_StartSound(mo, 222, nil) // sword landing spund
		mo.swordslamsound = false
		end
	end//----------------------------//
	if mo.state == S_EGG_BEATER_GUN1 then // aim at target for a second then fire
		mo.guntime = $+1
			// create an object to help prevent friendly fire//
		if mo.allycheck1 == false and mo.allycheck2 == false then
			mo.allycheck1 = P_SpawnMobj(mo.x+FixedMul(41*FRACUNIT, cos(mo.angle)),  
			mo.y+FixedMul(41*FRACUNIT, sin(mo.angle)), mo.z+(58*FRACUNIT), MT_JETTALLYCHECK)
			mo.allycheck1.angle = mo.angle
			mo.allycheck1.creator = mo
			
			mo.allycheck2 = P_SpawnMobj(mo.x+FixedMul(81*FRACUNIT, cos(mo.angle)),  
			mo.y+FixedMul(81*FRACUNIT, sin(mo.angle)), mo.z+(58*FRACUNIT), MT_JETTALLYCHECK)
			mo.allycheck2.angle = mo.angle
			mo.allycheck2.creator = mo
		end//----------------------------------------//
		if mo.target == nil then // try to find a target real quick
			A_FindTarget(mo, MT_PLAYER, 0)
		end // place retacual effect on target 
		if mo.target and mo.target.valid and (mo.targeteffect == 0 or mo.targeteffect.target != mo.target) then
		 mo.targeteffect = P_SpawnMobj(mo.target.x, mo.target.y, mo.target.z, MT_EGG_BEATER_TARGET)
		 mo.targeteffect.creator = mo
		 mo.targeteffect.target = mo.target 
		end
		if mo.guntime >= TICRATE and mo.target and mo.target.valid then 
			if P_CheckSight(mo, mo.target) then
			mo.state = S_EGG_BEATER_GUN2
			mo.ohnos = false // dont back up into pits
			mo.guntime = TICRATE // fire the next two shoots sooner
			mo.momz = $/2
				if P_IsObjectOnGround(mo) then
					S_StartSound(mo, 26, nil) // jump sound/ wacky work bench
					A_ZThrust(mo, 9, (1<<16)+0)
				end
			elseif P_IsObjectOnGround(mo) then // try to find the target by jumping
			 S_StartSound(mo, 26, nil) // jump sound/ wacky work bench
			A_ZThrust(mo, 18, (1<<16)+1)
			end
		end
		if mo.guntime >= 3*TICRATE then // give up trying to shoot
			mo.guntime = 0
			mo.state = S_EGG_BEATER_CHASE
		end
	end//----------------------------//
	
	//print(mo.floorrover)
	local sector = mo.subsector.sector
	
	if mo.floorrover and mo.floorrover.valid and mo.ohnos == false then // if over a fof pit reverse momentome to try and not fall in
	local fof = mo.floorrover.sector // check the control sectors special flags for pits
		if GetSecSpecial(fof.special, 1) == 6 or GetSecSpecial(fof.special, 1) == 7 then 
		mo.momx = $*-1
		mo.momy = $*-1
		mo.ohnos = true
		mo.fofless = false
		end
	elseif mo.floorrover == nil and sector and sector.valid and mo.ohnos == false and // if over a pit reverse momentome to try and not fall in
	(GetSecSpecial(sector.special, 1) == 6 or GetSecSpecial(sector.special, 1) == 7) and
	mo.floorz == sector.floorheight then  // make sure your not standing between two sectors
		mo.momx = $*-6/5
		mo.momy = $*-6/5
		mo.ohnos = true
	end	
	
end, MT_EGG_BEATER)//-------------------------//

addHook("MobjLineCollide", function(mo, line) //------do not cross line if the sector is more then 330*FRACUNIT  deep
	local lineangle = R_PointToAngle2(mo.x, mo.y, line.dx, line.dy)
	if mo.floorz-(350*FRACUNIT) > P_FloorzAtPos(mo.x+mo.momx, mo.y+mo.momy, mo.z, mo.height) then
		if mo.state == S_EGG_BEATER_CHASE then // try to back out
			mo.momx = $*-1/2
			mo.momy = $*-1/2
			//P_InstaThrust(mo, lineangle, FixedMul((5*FRACUNIT), mo.scale))
			return
		end
		return true
	end

end, MT_EGG_BEATER)//-------------------------//

addHook("MobjThinker", function(mo) //--------//
	if mo.target and mo.target.valid and 
	(mo.target.state == S_EGG_BEATER_MELEE3 or mo.target.state == S_EGG_BEATER_JUMP4) then
	// spawn sword effects
	mo.effecttime = $+1
		if mo.effecttime >= TICRATE/10 and mo.target.state == S_EGG_BEATER_MELEE3 then
		mo.attackeffect = P_SpawnMobj(mo.target.x+FixedMul(160*FRACUNIT, cos(mo.target.angle-ANG20)),  
		mo.target.y+FixedMul(160*FRACUNIT, sin(mo.target.angle-ANG20)), mo.z+40*FRACUNIT, MT_EGG_BEATER_CHARGE)
		mo.attackeffect.angle = mo.target.angle+ANGLE_90
		mo.attackeffect.spritexscale = FRACUNIT/3
		mo.attackeffect.spriteyscale = FRACUNIT/3
		mo.attackeffect.sizetime = 0
		mo.effecttime = 0
		end
		if mo.dragplayer and mo.dragplayer.valid then
		mo.dragplayer.momx = mo.momx
		mo.dragplayer.momy = mo.momy
		mo.dragtime = $-1
			if mo.dragtime <= 0 then
				mo.dragplayer = nil
			end
		end
	else
	mo.state = S_NULL
	end
end, MT_EGG_BEATER_MELEE)//-------------------------//

// block projectiles with sword!, git gud Fang!
local function SwordBlock(mo, moveingobj)

	if moveingobj.type != MT_EGG_BEATER_MELEE then
		return
	end

	if not (mo.z+(1*FRACUNIT) >= moveingobj.z+moveingobj.height)
	and not(moveingobj.z+(1*FRACUNIT) >= mo.z+mo.height) 
		if mo.valid and mo and mo.flags & MF_MISSILE and moveingobj.valid and moveingobj.type == MT_EGG_BEATER_MELEE then
			mo.health = 0
			if moveingobj.target.valid and moveingobj.target and moveingobj.target.type == MT_EGG_BEATER then
				moveingobj.target.stopsoon = $+TICRATE/2 //blocked projectiles at least slowdown egg beater
			end
			P_KillMobj(mo, moveingobj, moveingobj.target, 0) // kill self
		end
	else
		return nil
	end
end

addHook("MobjMoveCollide", SwordBlock, MT_NULL)
addHook("MobjCollide", SwordBlock, MT_NULL)

addHook("MobjThinker", function(mo) //--------//
	if mo.creator and mo.creator.valid then
	else
	mo.state = S_NULL
		return
	end
	if mo.target and mo.target.valid then
	else
	mo.state = S_NULL
		return
	end
	if mo.creator.state != S_EGG_BEATER_GUN1 and mo.creator.state != S_EGG_BEATER_GUN2
	and mo.creator.state != S_EGG_BEATER_GUN3 then
	mo.state = S_NULL
		return
	end
end, MT_EGG_BEATER_TARGET)//-------------------------//

addHook("MobjRemoved", function(mo) //--------//
	if mo.creator and mo.creator.valid then
		mo.creator.targeteffect = 0
	end
end, MT_EGG_BEATER_TARGET)//-------------------------//

addHook("MobjThinker", function(mo) //--------//
	mo.sizetime = $+1
	if mo.sizetime >= TICRATE/10 then
	mo.spritexscale = $+(FRACUNIT/3)
	mo.spriteyscale = $+(FRACUNIT/3)
	mo.sizetime = 0
	end
end, MT_EGG_BEATER_CHARGE)//-------------------------//

addHook("MobjMoveBlocked", function(mo)
	mo.ohnos = false 
	if mo.state == S_EGG_BEATER_MELEE3 then
		mo.stopsoon = $+1
		A_ZThrust(mo, 1, (1<<16)+0) // jump up small steps when charging forward
	end
end, MT_EGG_BEATER)//-------------------------//

addHook("MobjDamage", function(mo, inflictor, source, damagetype)
	mo.extravalue2 = 0 //fix A_Repeat bug
	
	if P_IsObjectOnGround(mo) then
		mo.momx = 0
		mo.momy = 0
	else
		mo.momz = 0
	end
	if inflictor and inflictor.valid and inflictor.type == MT_PLAYER then //if contact damage my a player push them up
		A_ZThrust(inflictor, 3, (0<<16)+0)
		if mo.state == S_EGG_BEATER_MELEE3 then
			inflictor.momx = $*-1
			inflictor.momy = $*-1
		end
	end
end, MT_EGG_BEATER)//-------------------------//

addHook("ShouldDamage", function(mo, inflictor, source, damagetype)
	// melee attack pushes players around 
	if inflictor and inflictor.valid and inflictor.type == MT_EGG_BEATER_MELEE then //if contact damage my a player push them up
		inflictor.dragplayer = mo
		inflictor.dragtime = TICRATE/10
	end
end, MT_PLAYER)//-------------------------//