freeslot(
"MT_INVADERPILOT",
"MT_INVADERSHIP",
"MT_INVADERSHIPFLOOR",
"MT_INVADERSHIPWALL",
"MT_INVADERCANNON",
"MT_INVADERMISSSLE",
"MT_INVADER_INFERNOEYE",
"MT_INVADER_INFERNOLAYER",
"MT_JETFUMEO1",
"S_INVADERPILOTLOOK",
"S_INVADERPILOTMOVE1",
"S_INVADERPILOTMOVE2",
"S_INVADERPILOTPAIN",
"S_INVADER",
"S_INVADER_DIE1",
"S_INVADER_DIE2",
"S_INVADER_DEAD",
"S_INVADERWALL",
"S_INVADERWALL_DIE1",
"S_INVADERWALL_DIE2",
"S_INVADERWALL_DEAD",
"S_INVADERCANNON",
"S_INVADERCANNON_DIE1",
"S_INVADERCANNON_DIE2",
"S_INVADERCANNON_DEAD",
"S_INVADERMISSSLE0",
"S_INVADERMISSSLE1",
"S_INVADERMISSSLE2",
"S_INVADERMISSSLE_EXPLODE1",
"S_INVADERMISSSLE_EXPLODE2",
"S_INVADERMISSSLE_EXPLODE3",
"S_INVADERMISSSLE_EXPLODE4",
"S_INVADER_INFERNOEYE",
"S_INVADER_INFERNOLAYER1",
"S_INVADER_INFERNOLAYER2",
"S_INVADER_INFERNOLAYER3",
"S_INVADER_INFERNOLAYER4",
"S_JETFUMEO1",
"S_JETFUMEO2",
"SPR_INZD",
"SPR_IMIS",
"SPR_INZS",
"SPR_IFER"
)

// "MT_INVADERSHIPSegment",
addHook("MobjSpawn", function(actor)
	actor.flags2 = MF2_SUPERFIRE
end, MT_INVADERMISSSLE)

addHook("MobjSpawn", function(actor)
	actor.z = $-1
	actor.flags2 = MF2_SPLAT|MF2_AMBUSH
	actor.renderflags = $ | RF_FLOORSPRITE | RF_NOSPLATBILLBOARD
	actor.spriteyscale = FRACUNIT
	actor.spritexscale = FRACUNIT
	actor.deathtimer = 0
	
end, MT_INVADERSHIP)

addHook("MobjSpawn", function(actor)
	actor.z = $-1
	actor.flags2 = MF2_SPLAT
	actor.renderflags = $ | RF_FLOORSPRITE | RF_NOSPLATBILLBOARD
	actor.spriteyscale = FRACUNIT
	actor.spritexscale = FRACUNIT
	actor.deathtimer = 0
		
end, MT_INVADERSHIPFLOOR)

addHook("MobjSpawn", function(actor)
	actor.z = $-1
	actor.flags2 = MF2_SPLAT
	actor.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
	actor.spritexscale = FRACUNIT
	P_CreateFloorSpriteSlope(actor)
	actor.reactiontime = -5
	actor.spriteyscale = FRACUNIT //8 // to get the right scale take recationtime / 10 * 2 //
	actor.spritexscale = FRACUNIT 
	actor.deathtimer = 0
end, MT_INVADERCANNON)

function A_Shiplat(actor, var1, var2)
	actor.floorspriteslope.o = {
	x = actor.x,
	y = actor.y,
	z = actor.z
	}
	actor.floorspriteslope.zdelta = (actor.reactiontime*FRACUNIT)/10
	actor.floorspriteslope.xydirection = actor.angle // actor.angle
	//actor.momx = cos(actor.angle)*15
	//actor.momy = sin(actor.angle)*15
end

	local s_closestdist
	local s_closestmo
	local s_sourceplayer
local function InvaderFindTarget(pmobj, mo)
	
	if mo.type != MT_PLAYER
	return else
	//print("player")
	end
	
	if mo.flags & (MF_NOCLIPTHING|MF_NOCLIP) or mo.flags2 & MF2_FRET
	or not mo.health or mo == pmobj
	or ((twodlevel or pmobj.flags2 & MF2_TWOD) and abs(pmobj.y-mo.y) > pmobj.radius)
	return end
		
	if not(P_CheckSight(pmobj, mo)) 
	return end
	
	local closedist = R_PointToDist2(mo.x, mo.y, pmobj.x, pmobj.y) //too close 
	if closedist <= 11371862 and pmobj.z-70*FRACUNIT < mo.z  then // and too high
	return end
	
	if pmobj.z-70*FRACUNIT < mo.z //just too high
	return end
	
	// target players that are closer but not too close
	local adist = P_AproxDistance(P_AproxDistance(pmobj.x-mo.x, pmobj.y-mo.y), pmobj.z-mo.z)
	if(adist > s_closestdist)
		return end
	
	s_closestmo = mo
	s_closestdist = adist
end

rawset(_G, "LO_InvaderLookForPlayers", function(mobj, player, dist)
	s_closestdist = dist+1
	s_closestmo = nil
	s_sourceplayer = player
	searchBlockmap("objects", InvaderFindTarget, mobj, mobj.x-dist, mobj.x+dist, mobj.y-dist, mobj.y+dist)
	// Check if it was in range!
	if(s_closestmo and s_closestmo.valid)
		and(P_AproxDistance(P_AproxDistance(mobj.x-s_closestmo.x, mobj.y-s_closestmo.y), mobj.z-s_closestmo.z) > FixedMul(dist, mobj.scale))
		s_closestmo = nil	 // out of range
	end
	return s_closestmo
end)


addHook("MobjSpawn", function(actor) // if too close to the floor move up more
	if P_FloorzAtPos(actor.x, actor.y, actor.z, actor.height) < actor.z -40*FRACUNIT then
		P_TeleportMove(actor, actor.x, actor.y, actor.z+25*FRACUNIT)
	end
end, MT_INVADERPILOT)

addHook("MobjThinker", function(mo)

	//---------spawn parts of the ship----------------//
	if mo.invadership == nil and mo.health > 0 then
	 for i = 0,3 do
			
			if i == 0 then
			 mo.xmodd = 64*FRACUNIT //64
			 mo.ymodd = 64*FRACUNIT
			 mo.xwall = 97*FRACUNIT // 128
			 mo.ywall = 0
			elseif i == 1 then
				mo.xmodd = -64*FRACUNIT
				mo.ymodd = 64*FRACUNIT
				mo.xwall = 0
				mo.ywall = 97*FRACUNIT // 128
			elseif i == 2 then
				mo.xmodd = -64*FRACUNIT
				mo.ymodd = -64*FRACUNIT
				mo.xwall = -97*FRACUNIT // 128
				mo.ywall = 0
			elseif i == 3 then
				mo.xmodd = 64*FRACUNIT
				mo.ymodd = -64*FRACUNIT
				mo.xwall = 0
				mo.ywall = -97*FRACUNIT // 128
			end
			
			//mo.shipangle = ANGLE_90*i
			
			// --- the bottom and the part that forms the platform--//
			mo.invadership = P_SpawnMobj((mo.x+mo.xmodd), (mo.y+mo.ymodd), mo.z-32*FRACUNIT, MT_INVADERSHIP)
			mo.invadership.angle = ANGLE_90*i
			mo.invadership.target = mo
			mo.invadership.xmodd = mo.xmodd 
			mo.invadership.ymodd = mo.ymodd 
			//-------spawn the four wing men--------------//
			mo.jettywingman = P_SpawnMobj((mo.x+mo.xmodd), (mo.y+mo.ymodd), mo.z, MT_JETTRUNNER)
			local jettywingman = mo.jettywingman
			jettywingman.wingman = true
			jettywingman.onship = true
			jettywingman.fade = false // go into fadeaway state if the ship is dead
			jettywingman.creator = mo
			jettywingman.xmodd = mo.xmodd 
			jettywingman.ymodd = mo.ymodd 
			//mo.invadership.atplace = true
				if i == 0 then
					mo.cannon1 = P_SpawnMobj(mo.x+60*FRACUNIT, mo.y, mo.z-63*FRACUNIT, MT_INVADERCANNON)
					mo.cannon1.angle = R_PointToAngle2(mo.x, mo.y, mo.cannon1.x, mo.cannon1.y)
					mo.ship1 = mo.invadership
					mo.ship1.xpostion = mo.x+mo.ship1.xmodd
					mo.ship1.ypostion = mo.y+mo.ship1.ymodd
				elseif i ==1 then
					mo.cannon2 = P_SpawnMobj(mo.x-60*FRACUNIT, mo.y, mo.z-63*FRACUNIT, MT_INVADERCANNON)
					mo.cannon2.angle = R_PointToAngle2(mo.x, mo.y, mo.cannon2.x, mo.cannon2.y)
					mo.ship2 = mo.invadership
					mo.ship2.xpostion = mo.x+mo.ship2.xmodd
					mo.ship2.ypostion = mo.y+mo.ship2.ymodd
				elseif i ==2 then
					mo.cannon3 = P_SpawnMobj(mo.x, mo.y-60*FRACUNIT, mo.z-63*FRACUNIT, MT_INVADERCANNON)
					mo.cannon3.angle = R_PointToAngle2(mo.x, mo.y, mo.cannon3.x, mo.cannon3.y)
					mo.ship3 = mo.invadership
					mo.ship3.xpostion = mo.x+mo.ship3.xmodd
					mo.ship3.ypostion = mo.y+mo.ship3.ymodd
				elseif i == 3 then
					mo.cannon4 = P_SpawnMobj(mo.x, mo.y+60*FRACUNIT, mo.z-63*FRACUNIT, MT_INVADERCANNON)
					mo.cannon4.angle = R_PointToAngle2(mo.x, mo.y, mo.cannon4.x, mo.cannon4.y)
					mo.ship4 = mo.invadership
					mo.ship4.xpostion = mo.x+mo.ship4.xmodd
					mo.ship4.ypostion = mo.y+mo.ship4.ymodd
				end
			
			// -- just for looks-----//
			mo.shipfloor = P_SpawnMobj((mo.x+mo.xmodd), (mo.y+mo.ymodd), mo.z, MT_INVADERSHIPFLOOR)
			mo.shipfloor.angle = ANGLE_90*i
			mo.shipfloor.target = mo
			mo.shipfloor.xmodd = mo.xmodd 
			mo.shipfloor.ymodd = mo.ymodd 
			
			//------the sides of the ship-------//
			mo.invaderwall1 = P_SpawnMobj((mo.x+mo.xwall), (mo.y+mo.ywall), mo.z-32*FRACUNIT, MT_INVADERSHIPWALL)
			//mo.invaderwall1.angle = (ANGLE_90*i)+ANGLE_90
			mo.invaderwall1.angle = R_PointToAngle2(mo.x, mo.y, mo.invaderwall1.x, mo.invaderwall1.y)+ANGLE_90
			mo.invaderwall1.target = mo
			mo.invaderwall1.deathtimer = 0
			mo.invaderwall1.spritexscale = FRACUNIT*3/2 // *2
			mo.invaderwall1.spriteyscale = FRACUNIT/2
			mo.invaderwall1.walldistance = R_PointToDist2(mo.x, mo.y, mo.invaderwall1.x, mo.invaderwall1.y)
			
			mo.dontmove = false // false
			mo.denypostivex = false
			mo.denynegativex = false
			mo.denypostivey = false
			mo.denynegativey = false
			mo.easttouch = false
			
			mo.misslecooldown = P_RandomRange(5*TICRATE, 9*TICRATE) //0
			mo.misslefired = false
			mo.suckproof = true
			mo.wherewedroppingboys = false
			if i >= 3 then
			break
			end
	 end
	end //
	
	mo.momz = 0 // stay floating
	if mo.suckproof == true and mo.health == 1 then
		mo.beingsucked = false //  got hit be suckabule now
		mo.suckproof = false
	elseif mo.health >= 2 then
		mo.beingsucked = true // suck proof to kirby.... hopefully 
		mo.suckproof = true
	end
	
	//------------fire the missle--------------------------//
	if mo.target == nil or mo.z-70*FRACUNIT < mo.target.z or mo.target.health <= 0 then // try to change target if its above you
		mo.target = nil
		mo.target = LO_InvaderLookForPlayers(mo, player, 15000*mo.scale)
		mo.dontmove = true
	end
			if (mo.target and mo.target.valid and P_FloorzAtPos(mo.x, mo.y, mo.z, mo.height) < mo.z -50*FRACUNIT)
			or mo.misslefired == true then
			mo.misslecooldown = $+1 // the timer needs to still go if the cannon is opean
			end
		if mo.misslecooldown >= 10*TICRATE then // opean cannon
		mo.cannon1.reactiontime = -120
		mo.cannon1.spriteyscale = -FRACUNIT/-16 //-23
		mo.cannon2.reactiontime = -120
		mo.cannon2.spriteyscale = -FRACUNIT/-16
		mo.cannon3.reactiontime = -120
		mo.cannon3.spriteyscale = -FRACUNIT/-16
		mo.cannon4.reactiontime = -120
		mo.cannon4.spriteyscale = -FRACUNIT/-16
		P_TeleportMove(mo.cannon1, (mo.x+85*FRACUNIT), (mo.y), (mo.z-83*FRACUNIT))
		P_TeleportMove(mo.cannon2, (mo.x-85*FRACUNIT), (mo.y), (mo.z-83*FRACUNIT))
		P_TeleportMove(mo.cannon3, (mo.x), (mo.y-85*FRACUNIT), (mo.z-83*FRACUNIT))
		P_TeleportMove(mo.cannon4, (mo.x), (mo.y+85*FRACUNIT), (mo.z-83*FRACUNIT))
			if mo.misslefired == false then
			A_PlayAttackSound(mo, 0, 0)
			mo.missle = P_SpawnMobj((mo.x), (mo.y), (mo.z-77*FRACUNIT), MT_INVADERMISSSLE)
			mo.missle.destscale = mo.scale*2
			mo.missle.misslespeed = 0
			mo.missle.angle = mo.angle
			mo.missle.target = mo
			mo.missle.tracer = mo.target
			mo.missle.infernotime = TICRATE*90
			mo.missle.sizemod = FRACUNIT
			mo.missle.infernos = 0
			mo.misslefired = true
			end
			if mo.misslecooldown > 11*TICRATE then
			mo.misslefired = false
			mo.misslecooldown = 0
			end
		elseif mo.misslecooldown < 20*TICRATE then //keep cannon closed
		mo.cannon1.reactiontime = -5 
		mo.cannon1.spriteyscale = FRACUNIT 
		mo.cannon2.reactiontime = -5 
		mo.cannon2.spriteyscale = FRACUNIT
		mo.cannon3.reactiontime = -5 
		mo.cannon3.spriteyscale = FRACUNIT
		mo.cannon4.reactiontime = -5 
		mo.cannon4.spriteyscale = FRACUNIT
		P_TeleportMove(mo.cannon1, (mo.x+27*FRACUNIT), (mo.y), (mo.z-63*FRACUNIT))
		P_TeleportMove(mo.cannon2, (mo.x-27*FRACUNIT), (mo.y), (mo.z-63*FRACUNIT))
		P_TeleportMove(mo.cannon3, (mo.x), (mo.y-27*FRACUNIT), (mo.z-63*FRACUNIT))
		P_TeleportMove(mo.cannon4, (mo.x), (mo.y+27*FRACUNIT), (mo.z-63*FRACUNIT))
		end
	//------------------------//
	
	if mo.ship1 and mo.ship2 and mo.ship3 and mo.ship4 then
		local xpostion = (mo.ship1.x+mo.ship2.x+mo.ship3.x+mo.ship4.x)/4
		local ypostion = (mo.ship1.y+mo.ship2.y+mo.ship3.y+mo.ship4.y)/4
		//if mo.target and mo.target.valid then
		//	P_InstaThrust(mo, mo.angle, FixedMul((3*FRACUNIT), mo.scale))
		//end
		P_TeleportMove(mo, (xpostion), (ypostion), (mo.z))		
		
		// set a point to return to when the ship parts hit a wall
		mo.ship1.xpostion = mo.x+mo.ship1.xmodd
		mo.ship1.ypostion = mo.y+mo.ship1.ymodd
		mo.ship2.xpostion = mo.x+mo.ship2.xmodd
		mo.ship2.ypostion = mo.y+mo.ship2.ymodd
		mo.ship3.xpostion = mo.x+mo.ship3.xmodd
		mo.ship3.ypostion = mo.y+mo.ship3.ymodd
		mo.ship4.xpostion = mo.x+mo.ship4.xmodd
		mo.ship4.ypostion = mo.y+mo.ship4.ymodd
		if mo.target == nil then // if no target dont move
			mo.dontmove = true
			mo.ship1.momx = 0
			mo.ship1.momy = 0
			mo.ship1.momz = 0
			mo.ship2.momx = 0
			mo.ship2.momy = 0
			mo.ship2.momz = 0
			mo.ship3.momx = 0
			mo.ship3.momy = 0
			mo.ship3.momz = 0
			mo.ship4.momx = 0
			mo.ship4.momy = 0
			mo.ship4.momz = 0
		end
		if mo.dontmove == false then
			P_TeleportMove(mo.ship1, (mo.x+mo.ship1.xmodd), (mo.y+mo.ship1.ymodd), (mo.z-32*FRACUNIT))
			P_InstaThrust(mo.ship1, mo.angle, FixedMul((3*FRACUNIT), mo.scale))
			P_TeleportMove(mo.ship2, (mo.x+mo.ship2.xmodd), (mo.y+mo.ship2.ymodd), (mo.z-32*FRACUNIT))
			P_InstaThrust(mo.ship2, mo.angle, FixedMul((3*FRACUNIT), mo.scale))
			P_TeleportMove(mo.ship3, (mo.x+mo.ship3.xmodd), (mo.y+mo.ship3.ymodd), (mo.z-32*FRACUNIT))
			P_InstaThrust(mo.ship3, mo.angle, FixedMul((3*FRACUNIT), mo.scale))
			P_TeleportMove(mo.ship4, (mo.x+mo.ship4.xmodd), (mo.y+mo.ship4.ymodd), (mo.z-32*FRACUNIT))
			P_InstaThrust(mo.ship4, mo.angle, FixedMul((3*FRACUNIT), mo.scale))
			
		end
		mo.dontmove = false
	end
end, MT_INVADERPILOT)

addHook("MobjThinker", function(mo)

	if mo.target and mo.target.valid and mo.target.health > 0 then
		mo.deathtimer = 0
		else
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
			if mo.state == S_INVADER then 
				mo.state = S_INVADER_DIE1 // start explodeing
			end
			if mo.state == S_INVADER_DEAD then
				mo.deathtimer = $+1
				// remove standabule flag
				if mo.deathtimer <= TICRATE/10 then
					mo.frame = FF_TRANS10|FF_ADD|A
					mo.flags = $&~MF_SOLID
				elseif mo.deathtimer < TICRATE/8 then
					mo.frame = FF_TRANS30|FF_ADD|A
				elseif mo.deathtimer < TICRATE/6 then
					mo.frame = FF_TRANS50|FF_ADD|A
				elseif mo.deathtimer < TICRATE/4 then
					mo.frame = FF_TRANS60|FF_ADD|A
				elseif mo.deathtimer < TICRATE/2 then
					mo.frame = FF_TRANS70|FF_ADD|A
				elseif mo.deathtimer > TICRATE then
					mo.frame = FF_TRANS90|FF_ADD|A
				end
			end
			
		end
end, MT_INVADERSHIP)

addHook("MobjThinker", function(mo)
	if mo.state == S_INVADERCANNON_DEAD then
				mo.deathtimer = $+1
				if mo.deathtimer <= TICRATE/10 then
					mo.frame = FF_TRANS10|FF_ADD|C
				elseif mo.deathtimer < TICRATE/8 then
					mo.frame = FF_TRANS30|FF_ADD|C
				elseif mo.deathtimer < TICRATE/6 then
					mo.frame = FF_TRANS50|FF_ADD|C
				elseif mo.deathtimer < TICRATE/4 then
					mo.frame = FF_TRANS60|FF_ADD|C
				elseif mo.deathtimer < TICRATE/2 then
					mo.frame = FF_TRANS70|FF_ADD|C
				elseif mo.deathtimer > TICRATE then
					mo.frame = FF_TRANS90|FF_ADD|C
				end
		end
end, MT_INVADERCANNON)

addHook("MobjDeath", function(mo, inflictor, source, damagetype) // tell the cannons to go into its death state
	mo.cannon1.state = S_INVADERCANNON_DIE1
	mo.cannon2.state = S_INVADERCANNON_DIE1
	mo.cannon3.state = S_INVADERCANNON_DIE1
	mo.cannon4.state = S_INVADERCANNON_DIE1
end, MT_INVADERPILOT)

addHook("MobjThinker", function(mo)

	if mo.target and mo.target.valid and mo.target.health > 0 then
			local xlocation = mo.target.x+mo.xmodd
			local ylocation = mo.target.y+mo.ymodd
			
			local xdiff = xlocation-mo.x
			local ydiff = ylocation-mo.y
			local zdiff = mo.target.z-mo.z
			
			mo.momx = xdiff/2
			mo.momy = ydiff/2
			mo.momz = zdiff/2
			mo.deathtimer = 0
		else
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
			if mo.state == S_INVADER then 
				mo.state = S_INVADER_DIE1 // start explodeing
			end
			if mo.state == S_INVADER_DEAD then
				mo.deathtimer = $+1
				if mo.deathtimer <= TICRATE/10 then
					mo.frame = FF_TRANS10|FF_ADD|A
				elseif mo.deathtimer < TICRATE/8 then
					mo.frame = FF_TRANS30|FF_ADD|A
				elseif mo.deathtimer < TICRATE/6 then
					mo.frame = FF_TRANS50|FF_ADD|A
				elseif mo.deathtimer < TICRATE/4 then
					mo.frame = FF_TRANS60|FF_ADD|A
				elseif mo.deathtimer < TICRATE/2 then
					mo.frame = FF_TRANS70|FF_ADD|A
				elseif mo.deathtimer > TICRATE then
					mo.frame = FF_TRANS90|FF_ADD|A
				end
			end
		end
end, MT_INVADERSHIPFLOOR)

//----------------- invader missle --------------------//
// stop hspeed of objects inside the inferno
local function Infernostop(mo,touchobj)
	if mo and mo.valid and touchobj and touchobj.valid and mo.z <= touchobj.z and mo.z+mo.radius >= touchobj.z+touchobj.radius and touchobj.type != MT_INVADERSHIP then
		P_DamageMobj(touchobj, mo, mo.target, 1, 0)
		if touchobj.valid and (touchobj.flags&MF_NOBLOCKMAP or touchobj.flags&MF_NOGRAVITY) then
			return false
		end
		if touchobj.valid and touchobj then
			local launchangle = R_PointToAngle2(touchobj.x, touchobj.y, mo.x, mo.y)
			P_InstaThrust(touchobj, launchangle, FixedMul((-1*FRACUNIT), mo.scale))
			if touchobj.momz >= -FRACUNIT/2 and touchobj.flags2&MFE_VERTICALFLIP then
				touchobj.momz = -FRACUNIT/2
			elseif touchobj.momz <= FRACUNIT/2 then
				touchobj.momz = FRACUNIT/2
			end
		end
	end
end
addHook("MobjMoveCollide", Infernostop, MT_INVADERMISSSLE)

addHook("MobjMoveCollide", Infernostop, MT_INVADER_INFERNOEYE)


addHook("MobjThinker", function(mo)
	if mo.target and mo.target.valid and mo.target.type == MT_EGG_BEATER and mo.sizemod == nil then // set size here instead
			mo.flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY // fly at target on spawn
			mo.tracer = mo.target.target
			mo.state = S_INVADERMISSSLE1
			mo.angle = mo.angle+ANGLE_90
			mo.destscale = $*2 //FRACUNIT*2
			mo.angle = mo.angle
			mo.infernotime = TICRATE*90
			mo.sizemod = FRACUNIT
			mo.infernos = 0
			mo.misslespeed = 1*FRACUNIT
			S_StartSound(mo.target, 675, nil) // missle launch sound or sfx_kc31
		end
	if mo.tracer and mo.tracer.valid then
		if (mo.state == S_INVADERMISSSLE0 and mo.z <= (mo.tracer.z+(mo.tracer.height*2))) or
		(mo.state == S_INVADERMISSSLE1 and	mo.flags != MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY) then
		// remove gravity begin chaseing the tracer
		mo.momz = 0
		mo.flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
		mo.state = S_INVADERMISSSLE1
		mo.misslespeed = 1*FRACUNIT
		mo.infernotime = TICRATE*90
		end
		if mo.state == S_INVADERMISSSLE1 or mo.state == S_INVADERMISSSLE2 then // graduly speed up
			if mo.misslespeed < 13*FRACUNIT then
			mo.misslespeed = $+1*FRACUNIT
			else
			mo.target = mo // can hit its own creator now
			end
		A_PlayAttackSound(mo, 0, 0)
		P_InstaThrust(mo, mo.angle, FixedMul((mo.misslespeed), mo.scale))
		
			if (mo.z > (mo.tracer.z+mo.tracer.height) or (mo.z+mo.height) < mo.tracer.z) and P_CheckSight(mo, mo.tracer) then // chase z postion
			local dest = mo.tracer
			local dist = P_AproxDistance(P_AproxDistance(dest.x - mo.x, dest.y - mo.y), dest.z - mo.z)
			local speedmul = FixedMul(mo.misslespeed, mo.scale)
			mo.momz = FixedMul(FixedDiv(dest.z - mo.z, dist), speedmul)
			else
			mo.momz = $/4
			end
		end
	end
	//-------------spawn inferno as your exploding-------------//---------------------------------------------------------//
	if (mo.state == S_INVADERMISSSLE_EXPLODE1 or mo.state == S_INVADERMISSSLE_EXPLODE2 or
	 mo.state == S_INVADERMISSSLE_EXPLODE3 or mo.state == S_INVADERMISSSLE_EXPLODE4) and mo.infernotime >= TICRATE/6 then
		local zspawnhight = mo.height
		mo.infernoeyeup = P_SpawnMobj(mo.x, mo.y, mo.z-zspawnhight, MT_INVADER_INFERNOEYE) // goes up
		mo.infernoeyeup.angle = mo.angle
		mo.infernoeyeup.creator = mo
		mo.infernoeyeup.scale = FRACUNIT
		mo.infernoeyeup.firespeed = 1
		mo.infernoeyedown = P_SpawnMobj(mo.x, mo.y, mo.z-zspawnhight, MT_INVADER_INFERNOEYE) // goes up
		mo.infernoeyedown.angle = mo.angle
		mo.infernoeyedown.creator = mo
		mo.infernoeyedown.scale = FRACUNIT
		mo.infernoeyedown.flags2 = $&~MF2_OBJECTFLIP //MF2_OBJECTFLIP
		mo.infernoeyedown.firespeed = -1
		mo.sizemod = $+(FRACUNIT/5)
		mo.infernotime = 0
		if mo.sourcehit and mo.sourcehit.valid then // set postion to the thing you hit
			local postionadd = FRACUNIT/7
			P_TeleportMove(mo, mo.sourcehit.x+FixedMul(postionadd, cos(mo.angle)), mo.sourcehit.y+FixedMul(postionadd, sin(mo.angle)), mo.sourcehit.z)
			mo.sourcehit.momx = $/7
			mo.sourcehit.momy = $/7
			mo.sourcehit = nil
		end
		mo.angle = $+ANG1
	end//
	mo.infernotime = $+1
end, MT_INVADERMISSSLE)

addHook("MobjDamage",function (mo, infernohit, source, damage, damagetype) 
	if infernohit and infernohit.valid and infernohit.type == MT_INVADERMISSSLE and mo.type != MT_INVADERSHIP then
	infernohit.sourcehit = mo
	infernohit.angle = R_PointToAngle2(mo.x, mo.y, infernohit.x, infernohit.y)
	end
end, MT_NULL)
//------------------------------------------------------//
addHook("MobjThinker", function(mo)

	if mo.infernowall == nil then // spawn the walls
		for i = 0,3 do // make the inferno pices
			mo.infernowall = P_SpawnMobj(mo.x, mo.y, mo.z, MT_INVADER_INFERNOLAYER)
			mo.infernowall.angle = ANGLE_90*i
			mo.infernowall.target = mo
			mo.infernowall.scale = FRACUNIT/2
			mo.infernowall.color = SKINCOLOR_CRIMSON
			if i >= 3 then
			break
			end
		end //
	end
	if mo.creator and mo.creator.valid then
		mo.scale = mo.creator.sizemod
	end
	mo.angle = $+ANG1
	A_ZThrust (mo,mo.firespeed,(1*(65536))+0) // set v speed, keep h speed
	
end, MT_INVADER_INFERNOEYE)

addHook("MobjThinker", function(mo)

	if mo.target and mo.target.valid and mo.target.health > 0 then
		local rotateradius = mo.target.radius/FRACUNIT
		local rotatespeed = 60*mo.scale/FRACUNIT
		A_Custom3DRotate (mo,(0*(65536))+rotateradius,(rotatespeed*(65536))+0)
		mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)+ANGLE_90
		mo.destscale = mo.target.scale
	else
	mo.momx = 0
	mo.momy = 0
	mo.momz = 0

	end

end, MT_INVADER_INFERNOLAYER) 
addHook("MobjRemoved", function(mo)// when removed remove target as well
	if mo.target and mo.target.valid then
	//print("wallgone")
	mo.target.state = S_NULL
	end
end, MT_INVADER_INFERNOLAYER) //--------------------------------------------------------------------------------------------//

// dont collide with other ship parts with the same target
addHook("MobjMoveCollide", function(mo, touchobj)
	if mo.target and mo.target.valid and mo.target.health > 0 then
		if touchobj and touchobj.valid and touchobj.target == mo.target and touchobj.type == mo.type then
			return false
		elseif touchobj and touchobj.valid and touchobj == mo.target then
			return false
		elseif touchobj.type == MT_PLAYER then
			local ship1 = mo.target.ship1
			local ship2 = mo.target.ship2
			local ship3 = mo.target.ship3
			local ship4 = mo.target.ship4
			ship1.momx = 0
			ship1.momy = 0
			ship1.momz = 0
			ship2.momx = 0
			ship2.momy = 0
			ship2.momz = 0
			ship3.momx = 0
			ship3.momy = 0
			ship3.momz = 0
			ship4.momx = 0
			ship4.momy = 0
			ship4.momz = 0
			mo.target.dontmove = true
			if mo.target.misslecooldown <= 6*TICRATE then
				mo.target.wherewedroppingboys = touchobj
			end
		end
	end
end, MT_INVADERSHIP)

addHook("MobjMoveBlocked", function(mo)
	if mo.momx > 0 then
	mo.target.denypostivex = true
	mo.target.denynegativex = false
	end
	if mo.momx < 0 then
	mo.target.denynegativex = true
	mo.target.denypostivex = false
	end
	if mo.momy > 0 then
	mo.target.denypostivey = true
	mo.target.denynegativey = false
	end
	if mo.momy < 0 then
	mo.target.denynegativey = true
	mo.target.denypostivey = false
	end
local ship1 = mo.target.ship1
local ship2 = mo.target.ship2
local ship3 = mo.target.ship3
local ship4 = mo.target.ship4
ship1.momx = 0
ship1.momy = 0
ship2.momx = 0
ship2.momy = 0
ship3.momx = 0
ship3.momy = 0
ship4.momx = 0
ship4.momy = 0
mo.target.dontmove = true	
P_TeleportMove(ship1, (ship1.xpostion), (ship1.ypostion), (mo.z))
P_TeleportMove(ship2, (ship2.xpostion), (ship2.ypostion), (mo.z))
P_TeleportMove(ship3, (ship3.xpostion), (ship3.ypostion), (mo.z))
P_TeleportMove(ship4, (ship4.xpostion), (ship4.ypostion), (mo.z))
end, MT_INVADERSHIP)

addHook("MobjThinker", function(mo)

	if mo.target and mo.target.valid and mo.target.health > 0 then

		A_Custom3DRotate (mo,(-41*(65536))+96,(60*(65536))+0)
		mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)+ANGLE_90
		mo.deathtimer = 0
		
	else
	mo.momx = 0
	mo.momy = 0
	mo.momz = 0
			if mo.state == S_INVADERWALL then 
				mo.state = S_INVADERWALL_DIE1 // start explodeing
			end
			if mo.state == S_INVADERWALL_DEAD then
				if mo.deathtimer == 0 then
				S_StartSound(mo, 364, nil) //splash sound
				end
				mo.deathtimer = $+1
				if mo.deathtimer <= TICRATE/10 then
					mo.frame = FF_PAPERSPRITE|FF_TRANS10|FF_ADD|B
				elseif mo.deathtimer < TICRATE/8 then
					mo.frame = FF_PAPERSPRITE|FF_TRANS30|FF_ADD|B
				elseif mo.deathtimer < TICRATE/6 then
					mo.frame = FF_PAPERSPRITE|FF_TRANS50|FF_ADD|B
				elseif mo.deathtimer < TICRATE/4 then
					mo.frame = FF_PAPERSPRITE|FF_TRANS60|FF_ADD|B
				elseif mo.deathtimer < TICRATE/2 then
					mo.frame = FF_PAPERSPRITE|FF_TRANS70|FF_ADD|B
				elseif mo.deathtimer > TICRATE then
					mo.frame = FF_PAPERSPRITE|FF_TRANS90|FF_ADD|B
				end
			end
	end

end, MT_INVADERSHIPWALL) 

// soc stuff in lua //
mobjinfo[MT_INVADERSHIP] = {
spawnstate = S_INVADER,
reactiontime = 8,
speed = 16*FRACUNIT,
radius = 64*FRACUNIT,
height = 32*FRACUNIT,
mass = 100,
flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_INVADERPILOT] = {
doomednum = 4001,
spawnstate = S_INVADERPILOTLOOK,
seestate = S_INVADERPILOTMOVE1,
attacksound = sfx_kc31,
painstate = S_INVADERPILOTPAIN,
deathstate = S_XPLD_FLICKY,
painsound = sfx_dmpain,
deathsound = sfx_pop,
spawnhealth = 3,
reactiontime = 8,
speed = 6*FRACUNIT,
radius = 22*FRACUNIT,
height = 38*FRACUNIT,
mass = 100,
flags = MF_SPECIAL|MF_SHOOTABLE|MF_ENEMY|MF_NOGRAVITY
}

mobjinfo[MT_INVADERSHIPFLOOR] = {
spawnstate = S_INVADER,
deathsound = sfx_s3kb4,
speed = 10*FRACUNIT,
radius = 63*FRACUNIT,
height = 2*FRACUNIT,
flags = MF_NOCLIP|MF_NOGRAVITY
}

mobjinfo[MT_INVADERSHIPWALL] = {
spawnstate = S_INVADERWALL,
speed = 10*FRACUNIT,
radius = 63*FRACUNIT,
height = 20*FRACUNIT,
flags = MF_NOCLIP|MF_NOGRAVITY
}

mobjinfo[MT_INVADERCANNON] = {
spawnstate = S_INVADERCANNON,
reactiontime = 16,
speed = 10*FRACUNIT,
radius = 20*FRACUNIT,
height = 20*FRACUNIT,
damage = 3,
spawnhealth = 0,
dispoffset = 0,
flags =  MF_NOGRAVITY|MF_NOBLOCKMAP
}

mobjinfo[MT_INVADER_INFERNOLAYER] = {
spawnstate = S_INVADER_INFERNOLAYER1,
speed = 10*FRACUNIT,
radius = 63*FRACUNIT,
height = 20*FRACUNIT,
flags = MF_NOGRAVITY|MF_NOBLOCKMAP
}
//-------------invader pilot states-----------------//

states[S_INVADERPILOTLOOK] = {
sprite = SPR_INZD,
frame = A,
tics = 5,
action = A_Look,
var1 = 1, 
var2 = 1, 
nextstate = S_INVADERPILOTLOOK
}

states[S_INVADERPILOTMOVE1] = {
sprite = SPR_INZD,
frame = A,
tics = 1,
action = A_FaceTarget,
nextstate = S_INVADERPILOTMOVE1
}

states[S_INVADERPILOTMOVE2] = {
sprite = SPR_POSS,
frame = A,
tics = 1,
action = A_Thrust,
var1 = 3,
var2 = 1,
nextstate = S_INVADERPILOTMOVE1
}

states[S_INVADERPILOTPAIN] = {
sprite = SPR_INZD,
frame = A,
tics = 35,
action = A_Pain,
nextstate = S_INVADERPILOTLOOK
}

//--------invader ship part states-------------------//

states[S_INVADER] = {
sprite = SPR_INZS,
frame = A,
tics = -1,
action = none,
nextstate = S_NULL
}

states[S_INVADER_DIE1] = {
sprite = SPR_INZS,
frame = A,
tics = 1,
action = A_BossScream,
var1 = 2,
nextstate = S_INVADER_DIE2
}

states[S_INVADER_DIE2] = {
sprite = SPR_INZS,
frame = A,
tics = 0,
action = A_Repeat,
var1 = 60,
var2 = S_INVADER_DIE1,
nextstate = S_INVADER_DEAD
}

states[S_INVADER_DEAD] = {
sprite = SPR_INZS,
frame = A,
tics = 38,
action = none,
nextstate = S_NULL
}

//--------wall---------//
states[S_INVADERWALL] = {
sprite = SPR_INZS,
frame = FF_PAPERSPRITE|B,
tics = 1,
action = none,
var1 = (-41*(65536))+63,
var2 = (60*(65536))+0,
nextstate = S_INVADERWALL
}

states[S_INVADERWALL_DIE1] = {
sprite = SPR_INZS,
frame = FF_PAPERSPRITE|B,
tics = 1,
action = A_BossScream,
var1 = 2,
nextstate = S_INVADERWALL_DIE2
}

states[S_INVADERWALL_DIE2] = {
sprite = SPR_INZS,
frame = FF_PAPERSPRITE|B,
tics = 0,
action = A_Repeat,
var1 = 60,
var2 = S_INVADERWALL_DIE1,
nextstate = S_INVADERWALL_DEAD
}

states[S_INVADERWALL_DEAD] = {
sprite = SPR_INZS,
frame = FF_PAPERSPRITE|B,
tics = 38,
action = none,
nextstate = S_NULL
}

//-------cannon---------//
states[S_INVADERCANNON] = {
sprite = SPR_INZS,
reactiontime = 16,
frame = C,
tics = 1,
action = A_Shiplat,
nextstate = S_INVADERCANNON
}

states[S_INVADERCANNON_DIE1] = {
sprite = SPR_INZS,
frame = C,
tics = 1,
action = A_BossScream,
var1 = 2,
nextstate = S_INVADERCANNON_DIE2
}

states[S_INVADERCANNON_DIE2] = {
sprite = SPR_INZS,
frame = C,
tics = 0,
action = A_Repeat,
var1 = 60,
var2 = S_INVADERCANNON_DIE1,
nextstate = S_INVADERCANNON_DEAD
}

states[S_INVADERCANNON_DEAD] = {
sprite = SPR_INZS,
frame = C,
tics = 38,
action = none,
nextstate = S_NULL
}
//---------invader missle states---------------//

states[S_INVADERMISSSLE0] = {
sprite = SPR_IMIS,
frame = A,
tics = 35,
action = none,
nextstate = S_INVADERMISSSLE1
}

states[S_INVADERMISSSLE1] = {
sprite = SPR_IMIS,
frame = B|FF_FULLBRIGHT,
tics = 1,
action = A_FaceTracer,
nextstate = S_INVADERMISSSLE2
}

states[S_INVADERMISSSLE2] = {
sprite = SPR_IMIS,
frame = A|FF_FULLBRIGHT,
tics = 1,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_INVADERMISSSLE1
}

states[S_INVADERMISSSLE_EXPLODE1] = {
sprite = SPR_BOM2,
frame = B|FF_FULLBRIGHT,
tics = 4,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_INVADERMISSSLE_EXPLODE2
}

states[S_INVADERMISSSLE_EXPLODE2] = {
sprite = SPR_BOM2,
frame = C|FF_FULLBRIGHT,
tics = 2,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_INVADERMISSSLE_EXPLODE3
}

states[S_INVADERMISSSLE_EXPLODE3] = {
sprite = SPR_BOM2,
frame = D|FF_FULLBRIGHT,
tics = 2,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_INVADERMISSSLE_EXPLODE4 
}

states[S_INVADERMISSSLE_EXPLODE4] = {
sprite = SPR_NULL,
frame = A|FF_FULLBRIGHT,
tics = 70,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_NULL 
}
 //--------------------------------inferno states----------------------------//
states[S_INVADER_INFERNOEYE] = {
sprite = SPR_NULL,
frame = A|FF_FULLBRIGHT,
tics = 700,
action = none,
var1 = 0,
var2 = 0,
nextstate = S_NULL 
}

states[S_INVADER_INFERNOLAYER1] = {
sprite = SPR_IFER,
frame = FF_PAPERSPRITE|FF_FULLBRIGHT|FF_TRANS10|FF_ADD|A,
tics = 8,
action = none,
var1 = (-41*(65536))+63,
var2 = (60*(65536))+0,
nextstate = S_INVADER_INFERNOLAYER2
}

states[S_INVADER_INFERNOLAYER2] = {
sprite = SPR_IFER,
frame = FF_PAPERSPRITE|FF_FULLBRIGHT|FF_TRANS30|FF_ADD|A,
tics = 4,
action = none,
var1 = (-41*(65536))+63,
var2 = (60*(65536))+0,
nextstate = S_INVADER_INFERNOLAYER3
}

states[S_INVADER_INFERNOLAYER3] = {
sprite = SPR_IFER,
frame = FF_PAPERSPRITE|FF_FULLBRIGHT|FF_TRANS40|FF_ADD|A,
tics = 4,
action = none,
var1 = (-41*(65536))+63,
var2 = (60*(65536))+0,
nextstate = S_INVADER_INFERNOLAYER4
}

states[S_INVADER_INFERNOLAYER4] = {
sprite = SPR_IFER,
frame = FF_PAPERSPRITE|FF_FULLBRIGHT|FF_TRANS50|FF_ADD|A,
tics = 4,
action = none,
var1 = (-41*(65536))+63,
var2 = (60*(65536))+0,
nextstate = S_NULL
}