freeslot(
"MT_JETTRUNNER",
"MT_JETTSEEKER",
"MT_JETRBULLET",
"MT_JETRBULLETTRAIL",
"MT_JETTALLYCHECK",
"S_JBULBBULLET1",
"S_JBULBBULLET2",
"S_JBULBBULLET3",
"S_JBULBBULLET4",
"S_JBULBBULLETTRAIL",
"S_JETR_STND",
"S_JETR_RUN0",
"S_JETR_RUN1",
"S_JETR_RUN2",
"S_JETR_RUN3",
"S_JETR_RUN4",
"S_JETR_RUN5",
"S_JETR_RUN6",
"S_JETR_RUN7",
"S_JETR_RUN8",
"S_JETR_ATK",
"S_JETR_ATK0",
"S_JETR_ATK1",
"S_JETR_ATK2",
"S_JETR_ATK3",
"S_JETR_ATK4",
"S_JETR_ATK5",
"S_JETR_PAIN0",
"S_JETR_PAIN1",
"S_JETR_PAIN2",
"S_JETR_PAIN3",
"S_JETR_DIE1",
"S_JETR_DIE2",
"S_JETR_DIE3",
"S_JETR_JUMP0",
"S_JETR_JUMP1",
"S_JETR_JUMP2",
"S_JETR_JUMP3",
"S_JETR_WINGM",
"S_JETR_FADE1",
"S_JETR_FADE2",
"S_JETR_FADE3",
"S_JETL_SEK0",
"S_JETL_SEK1",
"S_JETL_SEK2",
"S_JETL_SEK3",
"S_JETL_SEK4",
"S_JETL_ACHK1",
"SPR_JETR",
"SPR_JELE"
)

function A_AimBot (actor, var1, var2) // face target where you think they will go
	if actor.target and actor.target.valid then //  need a target first
	else
		return
	end
	
	local tar = actor.target
	local aimx = tar.x+(tar.momx*14)
	local aimy = tar.y+(tar.momy*14)

	local aimangle = R_PointToAngle2(actor.x, actor.y, aimx, aimy)
	local aimdistance = (((P_AproxDistance(tar.x - aimx, tar.y - aimy))/FRACUNIT)/11)+1
	
		if aimdistance > 25 then
			local anglediff = actor.angle - aimangle
			if (anglediff < 0) then
				actor.angle = $+(ANG1*aimdistance)
				//actor.frame = 3
			else
				actor.angle = $-(ANG1*aimdistance)
				//actor.frame = 2
			end
		else
			actor.angle = aimangle
		end

end

function A_RunnerShot(actor, var1, var2) // (actor, var1, var2)
	local tar = actor.target
	local locvar1 = var1
	local angle = angle_t
	local point = mobj_t
	local dur = tic_t
	local i = 0
	local tarDist = 0
	local projectile = var1
	
	actor.shot = P_SpawnMobj(actor.x+FixedMul(10*FRACUNIT, cos(actor.angle)),  
	actor.y+FixedMul(10*FRACUNIT, sin(actor.angle)), actor.z+(24*FRACUNIT), projectile)
	actor.shot.angle = actor.angle
	actor.shot.scale = actor.scale
	actor.shot.target = actor
	actor.shot.tracer = actor.target
	P_Thrust(actor.shot, actor.angle, FixedMul((30*FRACUNIT), actor.scale))
	S_StopSound(actor)
	A_PlayAttackSound(actor, 0, 0)
	//S_StartSound(actor, actor.attacksound)

end

addHook("MobjThinker", function(mo)
local tar = mo.target
local randomangle = P_RandomRange(1,8)
local angle = angle_t

	if mo.movejump == nill
		mo.movejump = false
		mo.laserwarning = 0
		mo.postionwarning = (36*FRACUNIT)
		mo.postionwarning2 = (36*FRACUNIT)
		mo.aimpostion = (200*FRACUNIT)
		mo.platformseeker = 0
		mo.formationattack = false
		mo.chasejump = false
		mo.waterjump = 10*FRACUNIT
		mo.allycheck1 = false
		mo.allycheck2 = false
		mo.suckproof = true
		mo.flicky = true
		mo.overpit = false
	end
	
	if mo.eflags&MFE_UNDERWATER then
		mo.waterjump = 6*FRACUNIT
	else
		mo.waterjump = 10*FRACUNIT
	end
	
	if mo.suckproof == true and mo.health <= 1 then
		mo.beingsucked = false //  got hit be suckabule now
		mo.suckproof = false
	elseif mo.health >= 2 then
		mo.beingsucked = true // suck proof to kirby.... hopefully 
		mo.suckproof = true
	end
	
		// create an object to help prevent friendly fire//
	if mo.state == S_JETR_ATK0 and mo.allycheck1 == false and mo.allycheck2 == false then
		mo.allycheck1 = P_SpawnMobj(mo.x+FixedMul(41*FRACUNIT, cos(mo.angle)),  
		mo.y+FixedMul(41*FRACUNIT, sin(mo.angle)), mo.z+(24*FRACUNIT), MT_JETTALLYCHECK)
		mo.allycheck1.angle = mo.angle
		mo.allycheck1.creator = mo
		
		mo.allycheck2 = P_SpawnMobj(mo.x+FixedMul(81*FRACUNIT, cos(mo.angle)),  
		mo.y+FixedMul(81*FRACUNIT, sin(mo.angle)), mo.z+(24*FRACUNIT), MT_JETTALLYCHECK)
		mo.allycheck2.angle = mo.angle
		mo.allycheck2.creator = mo
	end//----------------------------------------//
	
		 //----check if over a pit-------------//
	if mo.wingman and mo.subsector.sector then
		mo.mosector = mo.subsector.sector
		if mo.floorrover then // check fofs first
			mo.mosector = mo.floorrover.sector
		elseif mo.ceilingrover and mo.flags2&MF2_OBJECTFLIP then //if reverse gravity fof
			mo.mosector = mo.ceilingrover.sector
		elseif GetSecSpecial(mo.mosector.special, 1) >= 6 and  GetSecSpecial(mo.mosector.special, 1) <= 8 then
			mo.overpit = true
		end
		
	else
		mo.overpit = false
	end
	
	if mo.wingman then // the grey colored version
	mo.flicky = false
	mo.color = SKINCOLOR_JET
		if mo.creator and mo.creator.valid then
			//local ship = mo.tracer
			
			if mo.onship == true then // set postion to stay on the ship
				if mo.state == S_JETR_RUN1 or mo.state == S_JETR_RUN0 or mo.state == S_JETR_RUN2 then
					mo.state = S_JETR_WINGM // go to this state instead if you see someone
				end
				mo.momz = 0
				if mo.state == S_JETR_WINGM then
					if mo.creator.firstguydown then
						if mo.xmodd == 64*FRACUNIT and mo.ymodd == -64*FRACUNIT then
							mo.ymodd = -32*FRACUNIT  end //move fourth guy
						if mo.xmodd == -64*FRACUNIT and mo.ymodd == 64*FRACUNIT then
							mo.xmodd = -32*FRACUNIT  end //move seconed guy
					end
					if mo.creator.secondguydown then
						if mo.xmodd == 64*FRACUNIT and mo.ymodd == 64*FRACUNIT then
							mo.xmodd = 32*FRACUNIT  end //move first guy
						if mo.xmodd == -64*FRACUNIT and mo.ymodd == -64*FRACUNIT then
							mo.ymodd = -32*FRACUNIT  end //move third guy
					end
					if mo.creator.thirdguydown then
						if mo.xmodd == -64*FRACUNIT and mo.ymodd == 64*FRACUNIT then
							mo.ymodd = -32*FRACUNIT  end //move seconed guy
						if mo.xmodd == 64*FRACUNIT and mo.ymodd == -64*FRACUNIT then
							mo.xmodd = 32*FRACUNIT  end //move fourth guy
					end
					if mo.creator.fourthguydown then
						if mo.xmodd == 64*FRACUNIT and mo.ymodd == 64*FRACUNIT then
							mo.ymodd = 32*FRACUNIT  end //move first guy
						if mo.xmodd == -64*FRACUNIT and mo.ymodd == -64*FRACUNIT then
							mo.xmodd = -32*FRACUNIT  end //move third guy
					end
				end
				P_TeleportMove(mo, (mo.creator.x+mo.xmodd), (mo.creator.y+mo.ymodd), (mo.creator.z-1))
				if mo.creator.wherewedroppingboys != false and mo.creator.wherewedroppingboys.valid and mo.overpit == false then
					mo.target = mo.creator.wherewedroppingboys 
					if mo.target.z < (mo.z-70*FRACUNIT) then
						mo.extravalue2 = 0
						mo.reactiontime = 1*TICRATE
						mo.state = S_JETR_JUMP0
						P_SetObjectMomZ(mo, (mo.waterjump/5), false)
						S_StartSound(mo, 197) //jump sound
						mo.formationattack = true // attack after jump
						mo.movecount = 0 //bug fix
						mo.onship = false
					else
						mo.creator.wherewedroppingboys = false
					end
				end
			end

		elseif mo.fade == false then // fade away
			mo.onship = false
			mo.extravalue2 = 0 
			mo.flags = MF_NOCLIP | MF_NOGRAVITY //become intangabule
			mo.state = S_JETR_FADE1
			mo.fade = true
		end
		if mo.onship == true then
			return
		end
	else
	mo.color = SKINCOLOR_DUSK
	mo.wingman = false
		if mo.state == S_XPLD1 and mo.flicky == true then // if your a wingman you dont have Flicky's
			mo.state = S_XPLD_FLICKY
			mo.flicky = false
		end
	end
	
	if (tar) and (tar.valid) then
	mo.postion = P_AproxDistance(tar.x - mo.x, tar.y - mo.y)
	mo.postionheight = (tar.z - mo.z)
	 if mo.state == S_JETR_STND then // keep attacking if hit into a pit
		mo.state = S_JETR_ATK
	 end
	end

		//---------------jump conditions------------------------//
		
		if (mo.tracer) and (mo.tracer.valid) and mo.tracer != mo.test then // jump if an ally starts an attack
		mo.allypostion = P_AproxDistance(mo.tracer.x - mo.x, mo.tracer.y - mo.y)
		//mo.allyangle = R_PointToAngle2(mo.x, mo.y, mo.tracer.x, mo.tracer.y)
		if mo.allypostion <= (195*FRACUNIT) and mo.tracer != mo.test and
		(mo.state == S_JETR_ATK0 or mo.state == S_JETR_RUN8 or mo.state == S_JETR_RUN7 or
		mo.state == S_JETR_RUN6 or mo.state == S_JETR_RUN5 or mo.state == S_JETR_RUN4 or
		mo.state == S_JETR_RUN3 or mo.state == S_JETR_RUN2 or mo.state == S_JETR_RUN1) then
			mo.angle = $+ANGLE_180
			mo.state = S_JETR_JUMP0
			P_SetObjectMomZ(mo, (mo.waterjump), false)
			S_StartSound(mo, 197) //jump sound
			mo.formationattack = true // attack after jump
			mo.movecount = 0 //bug fix
		end
	end
		
	if mo.formationattack == true and mo.state == S_JETR_RUN4 then
	mo.formationattack = false
	mo.state = S_JETR_ATK
	end
		
	if (mo.platformseeker != 0) then
	//????
	elseif tar and tar.valid and mo.state == S_JETR_ATK0 then
		if (tar.z -(20*FRACUNIT)) > mo.z then
		mo.chasejump = true
		end
	end

	// when target is on top of a platform jump to reach them also check if too heigh. movecount check is used to prevent a bug
	if (mo.state == S_JETR_RUN8 and (tar.z -(20*FRACUNIT)) > mo.z and tar.state != S_PLAY_SPINDASH and tar.state != S_PLAY_JUMP and tar.state != S_PLAY_PAIN 
	and tar.floorz and mo.postion <= (250*FRACUNIT) and mo.postionheight < (180*FRACUNIT)) or mo.movecount < -10 then
		mo.state = S_JETR_JUMP0
		P_SetObjectMomZ(mo, (mo.waterjump), false)
		S_StartSound(mo, 197) //jump sound
		mo.movecount = 0 //bug fix
	elseif mo.state == S_JETR_RUN3 and tar.z < mo.z and mo.flags2&MF2_AMBUSH and //if too close or too far jump down
	(mo.postion > (1890*FRACUNIT) or mo.postion <= (90*FRACUNIT)) then
		mo.state = S_JETR_JUMP0
		P_SetObjectMomZ(mo, (mo.waterjump), false)
		S_StartSound(mo, 197) //jump sound
		mo.movecount = 0 //bug fix
	elseif mo.state == S_JETR_RUN4 and mo.postion <= (190*FRACUNIT) and tar.z <= mo.z then //if close attack early
		mo.extravalue2 = 0
		mo.state = S_JETR_ATK
	end
	
	// if stuck jumping close to a wall gain some speed so you can get over it
	if mo.momx <= (2*FRACUNIT) and mo.momy <= (2*FRACUNIT) and 
	mo.momx >= (-2*FRACUNIT) and mo.momy >= (-2*FRACUNIT) and mo.state == S_JETR_JUMP2 then
	mo.movejump = true
	end
	if mo.movejump == true and mo.state == S_JETR_JUMP2 then
	P_Thrust(mo, mo.angle, FixedMul((1*(FRACUNIT)/4), mo.scale))
	else
	mo.movejump = false
	end
	
		//---seek the heigh ground---//----------------------------------//
	if (mo.state == S_JETR_RUN3 or mo.state == S_JETR_RUN4) and not (mo.platformseeker) then 
	// spawn an object that can check for platforms
	mo.platformseeker = P_SpawnMobj(mo.x, mo.y, mo.z+(104*FRACUNIT), MT_JETTSEEKER)
	P_TeleportMove(mo.platformseeker, mo.platformseeker.x , mo.platformseeker.y , mo.z +(104*FRACUNIT))
	mo.platformseeker.creator = mo

		if (randomangle == 1) then
		mo.platformseeker.angle = mo.angle
		elseif (randomangle == 2) then
		mo.platformseeker.angle = mo.angle-(mo.angle/4)
		elseif (randomangle == 3) then
		mo.platformseeker.angle = mo.angle-(mo.angle/3)
		elseif (randomangle == 4)then
		mo.platformseeker.angle = mo.angle-(mo.angle/2)
		elseif (randomangle == 5)then
		mo.platformseeker.angle = (mo.angle*-1)
		elseif (randomangle == 6)then
		mo.platformseeker.angle = (mo.angle*-1)-(mo.angle/2)
		elseif (randomangle == 7)then
		mo.platformseeker.angle = (mo.angle*-1)-(mo.angle/3)
		elseif (randomangle == 8)then
		mo.platformseeker.angle = (mo.angle*-1)-(mo.angle/4)
		end

	end
	
end, MT_JETTRUNNER)//-------------------------------------------------------------------------------//

addHook("MobjThinker", function(mo)
	if mo.setonce == nill then
	mo.color = SKINCOLOR_RED
	mo.setonce = true
	mo.playercontrol = false
	end
	
	local owner = mo.target
	mo.trail = P_SpawnMobj(mo.x, mo.y, mo.z-(24*FRACUNIT), MT_JETRBULLETTRAIL)
	mo.trail.color = SKINCOLOR_RED
	mo.trail.angle = mo.angle+ANGLE_90
	
	if mo.tracer and mo.tracer.valid then // track the tracers z postion
		if mo.z-(25*FRACUNIT) > mo.tracer.z and mo.chaseonce == nill then
		local dest = mo.tracer
		local dist = P_AproxDistance(P_AproxDistance(dest.x - mo.x, dest.y - mo.y), dest.z - mo.z)
		local speedmul = FixedMul(30*FRACUNIT, mo.scale)
		mo.momz = FixedMul(FixedDiv(dest.z - mo.z, dist), speedmul)
		
			mo.chaseonce = true
		end
	end
	
	if mo.target and mo.target.valid and owner.player and owner.player.valid then
	mo.playercontrol = true
	end
	
end, MT_JETRBULLET) //------------------------------------------------------------------------

//----------dont harm players if owned by a player
addHook("ShouldDamage", function(mo, moinflictor, mosource, damage, damagetype)
	if moinflictor != nil and moinflictor.valid and (moinflictor.type == MT_JETRBULLET)and
	 moinflictor.playercontrol == true then
		return false
	end
end,  	MT_PLAYER)

//------------- platform seeker think ----------------------------//
addHook("MobjThinker", function(mo)
// if on a platform and heigher then creator make them jump
	if ( P_IsObjectOnGround(mo) and mo.creator.valid and
	((mo.floorz) or (mo.eflags & MFE_ONGROUND)) ) then
		if mo.creator and mo.z-10 > mo.creator.z and (mo.creator.state == S_JETR_RUN8 or mo.creator.state == S_JETR_RUN7 or
		mo.creator.state == S_JETR_RUN6 or mo.creator.state == S_JETR_RUN5 or mo.creator.state == S_JETR_RUN4 or
		mo.creator.state == S_JETR_RUN3 or mo.creator.state == S_JETR_RUN2 or mo.creator.state == S_JETR_RUN1) then
			local creatorsector = mo.creator.subsector
			if mo.state != S_JETL_SEK4 or mo.subsector.sector == creatorsector.sector then
				P_RemoveMobj(mo) // jump less when on slopes
			else
			mo.oldtar = mo.creator.target
			mo.creator.target = mo
			mo.creator.state = S_JETR_JUMP0
			P_SetObjectMomZ(mo.creator, (mo.creator.waterjump), false)
			mo.creator.chasejump = false 
			S_StartSound(mo.creator, 197) //jump sound
			end
		end
	end
	
end, MT_JETTSEEKER) //--------------------------------------

//----------------------- ally checker think set postion relative to creator---------------------//
addHook("MobjThinker", function(mo)
	if mo.creator and mo.creator.valid then
		local creator = mo.creator
		//local checkdist = 0
		if creator.type == MT_EGG_BEATER then
			if creator.allycheck1 == mo then
			P_TeleportMove(mo, creator.x+FixedMul(82*FRACUNIT, cos(creator.angle)), creator.y+FixedMul(82*FRACUNIT, sin(creator.angle)), creator.z+(58*FRACUNIT))
			elseif creator.allycheck2 == mo then 
			P_TeleportMove(mo, creator.x+FixedMul(164*FRACUNIT, cos(creator.angle)), creator.y+FixedMul(164*FRACUNIT, sin(creator.angle)), creator.z+(58*FRACUNIT))
			end
			return
		end
		if creator.allycheck1 == mo then
			P_TeleportMove(mo, creator.x+FixedMul(82*FRACUNIT, cos(creator.angle)), creator.y+FixedMul(82*FRACUNIT, sin(creator.angle)), creator.z+(24*FRACUNIT))
		elseif creator.allycheck2 == mo then 
			P_TeleportMove(mo, creator.x+FixedMul(164*FRACUNIT, cos(creator.angle)), creator.y+FixedMul(164*FRACUNIT, sin(creator.angle)), creator.z+(24*FRACUNIT))
		end
	end
end, MT_JETTALLYCHECK)

----------------// when platform seeker is removed tell creator its gone //-----------------
addHook("MobjRemoved", function(mo)
	if mo.creator and mo.creator.valid then
		mo.creator.platformseeker = 0
		if (mo.oldtar) then //remind creator of its orignal target
		mo.creator.target = mo.oldtar
		end
		
	end
end, MT_JETTSEEKER)

// block other projectiles
local function ProjectleBlock(mo, moveingobj)
	if not mo.valid and not mo then
			return
	end
	
	if not (mo.z+(1*FRACUNIT) >= moveingobj.z+moveingobj.height)
	and not(moveingobj.z+(1*FRACUNIT) >= mo.z+mo.height)
		if mo.valid and mo and mo.flags & MF_MISSILE and moveingobj.valid and moveingobj.type == MT_JETRBULLET then
			mo.health = 0
			moveingobj.health = 0
			moveingobj.flags = $&~ MF_PAIN
			P_KillMobj(moveingobj, mo, mo.target, 0) // kill object
			P_KillMobj(mo, moveingobj, moveingobj.target, 0) // kill self
		end
	else
		return nil
	end
end

addHook("MobjMoveCollide", ProjectleBlock, MT_NULL)
addHook("MobjCollide", ProjectleBlock, MT_NULL)

//--------------if an enemy's ally is in the way do not shoot--------//
local function AllyCheck(mo, ally)
	if not (mo.z+(1*FRACUNIT) >= ally.z+ally.height)
	and not(ally.z+(1*FRACUNIT) >= mo.z+mo.height) then
		if ally.valid and (ally.flags & MF_ENEMY or ally.flags & MF_BOSS) then //
			if mo.creator.valid and ally != mo.creator and mo.creator.state == S_EGG_BEATER_GUN1 and P_IsObjectOnGround(mo.creator) and mo.creator.momz == 0 then
				S_StartSound(mo, 26, nil) // jump sound/ wacky work bench
				A_ZThrust(mo, 18, (1<<16)+1) // jump above ally
				return
			end
			if mo.creator.valid and ally != mo.creator and mo.creator.type != MT_JETTRUNNER then
				return
			end
			if mo.creator.valid and ally != mo.creator and (mo.creator.state == S_JETR_ATK0 or mo.creator.state == S_JETR_ATK1) then
				if mo.creator.wingman and mo.creator.onship == true then
					mo.creator.extravalue2 = 0
					mo.creator.state = S_JETR_WINGM
					A_FindTarget(mo, MT_PLAYER, 0)
					mo.creator.reactiontime = 1*TICRATE
					mo.creator.movecount = 0
					return
				end
				mo.creator.extravalue2 = 0
				mo.creator.reactiontime = 1*TICRATE
				mo.creator.angle = $+ANGLE_180
				mo.creator.state = S_JETR_JUMP0
				P_SetObjectMomZ(mo.creator, (mo.creator.waterjump), false)
				S_StartSound(mo.creator, 197) //jump sound
				mo.creator.formationattack = true // attack after jump
				mo.creator.movecount = 0 //bug fix
			end
		end
	else
		return nil
	end
end

addHook("MobjMoveCollide", AllyCheck, MT_JETTALLYCHECK)
addHook("MobjCollide", AllyCheck, MT_JETTALLYCHECK)

//--------------------when jetty syn runner is removed remove all it child objects--------//
addHook("MobjRemoved", function(mo)

	if mo.aim and mo.aim.valid then
		P_RemoveMobj(mo.aim)
	end
	if mo.test and mo.test.valid then
		mo.test.state = S_NULL
	end
	if mo.platformseeker and mo.platformseeker.valid then
		P_RemoveMobj(mo.platformseeker)
	end
	if mo.warning and mo.warning.valid then
		P_RemoveMobj(mo.warning)
	end
end, MT_JETTRUNNER)

//-------------//

addHook("MobjDeath", function(mo, inflictor, damagetype) // stop moveing on death

	mo.momx = 0
	mo.momy = 0
	mo.momz = 0

	//return true
end, MT_JETRBULLET)

addHook("MobjDeath", function(mo, inflictor, damagetype) 

	if mo.valid and mo and mo.wingman then
		mo.state = mo.info.deathstate // go to death state but dont die 
		return true // no points for you
	end

end, MT_JETTRUNNER)

//------------------tell creator that you are gone--------------------------//
addHook("MobjRemoved", function(mo)
	if mo.creator and mo.creator.valid then
		if mo.creator.allycheck1 == mo then
			mo.creator.allycheck1 = false
		elseif mo.creator.allycheck2 == mo then 
			mo.creator.allycheck2 = false
		end
	end
end, MT_JETTALLYCHECK)

addHook("MobjDamage", function(mo, inflictor, source, damagetype)
	mo.extravalue2 = 0 //fix A_Repeat bug
	mo.onship = false // fall off the ship
	if	mo.creator and mo.creator.valid then
		if mo.xmodd == 64*FRACUNIT and mo.ymodd == 64*FRACUNIT then
		mo.creator.firstguydown = true
		end
		if mo.xmodd == -64*FRACUNIT and mo.ymodd == 64*FRACUNIT then
		mo.creator.secondguydown = true
		end
		if mo.xmodd == -64*FRACUNIT and mo.ymodd == -64*FRACUNIT then
		mo.creator.thirdguydown = true
		end
		if mo.xmodd == 64*FRACUNIT and mo.ymodd == -64*FRACUNIT then
		mo.creator.fourthguydown = true
		end
	end
end, MT_JETTRUNNER)//-------------------------//