freeslot(
"MT_TURBOBUZZ",
"MT_TURBBULLET",
"MT_TURBFLAMEWALL",
"S_TBUZLOOK",
"S_TBUZACTIVE1",
"S_TBUZACTIVE2",
"S_TBUZZOOM0",
"S_TBUZZOOM1",
"S_TBUZZOOM2",
"S_TBUZZOOM3",
"S_TBUZZOOM4",
"S_TBUZSHOOT0",
"S_TBUZSHOOT1",
"S_TBUZSHOOT2",
"S_TBUZSHOOT3",
"S_TBUZSHOOT4",
"S_TBUZBBULLET1",
"S_TURBFLAMEWALL1",
"S_TURBFLAMEWALL2",
"S_TURBFLAMEWALL3",
"S_TURBFLAMEWALL4",
"S_TURBFLAMEWALL5",
"S_TURBFLAMEWALL6",
"S_TBUZWAYPOINT",
"SPR_TBUZ",
"SPR_TBUL",
"SPR_TWAL"
)

addHook("MobjThinker", function(mo)
if mo.health > 0 then //--//
	local tar = mo.target
 if mo.fuel == nill then
	mo.fuel = true
	mo.aim = 0
	mo.potshot = false
	mo.chasedistance = 0
	mo.otherchasedistance = 0
	mo.truetarget = 0
	mo.truetargetset = false
	mo.seeabule = 0
	mo.startangle = mo.angle
	mo.mosector = 0
	mo.overpit = false
 end
 
	mo.color = SKINCOLOR_SEAFOAM 
	
	if mo.state == S_TBUZACTIVE1 and mo.fuel == true then
	S_StartSound(mo, 440)
	mo.fuel = false
	mo.attackmode = false
	mo.flags = 4196869// MF2_DONTDRAW
		if tar.player then
		P_Thrust(mo, mo.angle, FixedMul((tar.player.normalspeed*2), tar.scale))
		end
	mo.state = S_TBUZZOOM0 // dash once
	end
	
	if tar and tar.valid then
	mo.chasedistance = (P_AproxDistance(tar.x - mo.x, tar.y - mo.y))
	else
	mo.state = S_TBUZLOOK
	end
	
	 //----check if over a pit-------------//
	if mo.subsector.sector then
		mo.mosector = mo.subsector.sector
		if mo.floorrover then // check fofs first
			mo.mosector = mo.floorrover.sector
		elseif mo.ceilingrover and mo.flags2&MF2_OBJECTFLIP then //if reverse gravity fof
			mo.mosector = mo.ceilingrover.sector
		elseif GetSecSpecial(mo.mosector.special, 1) >= 6 and  GetSecSpecial(mo.mosector.special, 1) <= 8 then
			mo.overpit = true
		end
		
	end
	
	if mo.chasedistance > 400*FRACUNIT and mo.attackmode == false and mo.state != S_TBUZZOOM0 and mo.state != S_TBUZZOOM1 then
		mo.attackmode = true
		mo.state = S_TBUZSHOOT0 //
	elseif mo.attackmode == true and mo.fuel == false then
	// slow down over time
			if mo.momx > 21*FRACUNIT then
				mo.momx = $-2*FRACUNIT 
			end
			
			if mo.momy > 21*FRACUNIT then
				mo.momy = $-2*FRACUNIT 
			end
			
			if mo.momx < -21*FRACUNIT then
				mo.momx = $+2*FRACUNIT 
			end
			
			if mo.momy < -21*FRACUNIT then
				mo.momy = $+2*FRACUNIT 
			end
			// if you too slow start attacking
			if mo.momy > -10*FRACUNIT and mo.momy < 10*FRACUNIT and mo.momx > -10*FRACUNIT and mo.momx < 10*FRACUNIT and mo.attackmode == false then
			//P_DamageMobj(mo)
			mo.attackmode = true
			mo.state = S_TBUZSHOOT0 //
			end
			if mo.chasedistance > 1900*FRACUNIT then // if target is really far away move very slowly back
				local actionspd = 2*FRACUNIT 
					if mo.eflags&MFE_UNDERWATER
					actionspd = $*2/3
					end
				P_InstaThrust(mo, mo.startangle, FixedMul(-actionspd, mo.scale))
			elseif mo.momx < 32*FRACUNIT and mo.momx > -32*FRACUNIT and mo.momy < 32*FRACUNIT and mo.momy > -32*FRACUNIT then
				local actionspd = 22*FRACUNIT 
					if mo.eflags&MFE_UNDERWATER
					actionspd = $*2/3
					end
				if mo.potshot == true then
					P_InstaThrust(mo, mo.startangle, FixedMul(-actionspd, mo.scale))
				else
					P_InstaThrust(mo, mo.startangle, FixedMul(actionspd, mo.scale))
				end
			end
	end
	
			// should always be 26 fracunits above the floor
	mo.floorbelow = 26*FRACUNIT+P_FloorzAtPos(mo.x, mo.y, mo.z, mo.height)
	local zdiff = mo.floorbelow-mo.z
	
	// stop if over a pit -----  ----//
	if mo.overpit == true then //120 mo.z-120*FRACUNIT > mo.floorz or (mo.z+100*FRACUNIT < mo.ceilingz and mo.flags2&MF2_OBJECTFLIP)
		if mo.attackmode == false then
			mo.attackmode = true
			mo.state = S_TBUZSHOOT0
		end
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
	elseif mo.z != mo.floorbelow and mo.state != S_TBUZLOOK then
	mo.momz = zdiff/16
	end
	
end--//
end, MT_TURBOBUZZ)

// flame wall hooks ////////////////////
addHook("MobjMoveBlocked", function(mo)

	P_KillMobj(mo, mo, mo, 0)
end, MT_TURBFLAMEWALL)

addHook("MobjThinker", function(mo)
	
	if mo.timer == nil then
		mo.timer = 1
		if mo.target and mo.target.valid and mo.target.type == MT_EGG_BEATER then
			mo.angle = mo.angle+ANGLE_90
		end
	else
		mo.timer = $+1
	end
	
	mo.spritexscale = $+(FRACUNIT/50) //55
	mo.friction = FRACUNIT 
	
	if mo.timer > TICRATE*5 // after 10 seconds remove self
		mo.state = S_NULL
	end
end, MT_TURBFLAMEWALL)
//////////////////////////////////////

addHook("MobjThinker", function(mo)
	if mo.tracer and mo.tracer.valid then
		if mo.floorz < mo.tracer.floorz then
		mo.momz = 0
		P_InstaThrust(mo, mo.angle, FixedMul((20*FRACUNIT), mo.scale))
		end
	end

// fall and hit the floor then release a wave of fire
  if mo.wave == nil and mo.state != S_TBUZBBULLET1 then //mo.state != S_TBUZBBULLET1  mo.z <= mo.floorz  and 
	for i = -6,6 do

		mo.anglemod = mo.angle+((ANG2*2)*i)
		//print(i)
		mo.wave = P_SpawnMobj(mo.x+FixedMul(1*FRACUNIT, cos(mo.anglemod)),  
		mo.y+FixedMul(1*FRACUNIT, sin(mo.anglemod)), mo.z, MT_TURBFLAMEWALL)
		mo.wave.angle = (mo.anglemod)+ANGLE_90
		mo.wave.target = mo.target
		P_Thrust(mo.wave, mo.anglemod, FixedMul((20*FRACUNIT), mo.scale))
		mo.wave.friction = FRACUNIT
		mo.wave.attackangle = mo.anglemod // rememer the angle you moved from
		mo.wave.spritexscale = $/4
		A_PlayAttackSound(mo, 0, 0)
		//S_StopSound(actor)
		//S_StartSound(actor, 475) 
		if i == 8 then
			break
		end
	end
  end

end, MT_TURBBULLET)

addHook("ShouldDamage", function(mo, moinflictor, mosource, damage, damagetype) // no contact damage from touching turbo buzz
	if moinflictor != nil and moinflictor.valid and (moinflictor.type == MT_TURBOBUZZ) then
		return false
	end
end,  	MT_PLAYER )
